import pandas as pd


### Part 1

df2=pd.read_csv("input/media_reach/20151201-20160630pc_consistent.csv", index_col=[0,1])
df2=df2[["CEMP", "Origo csoport"]]
df3=pd.read_csv("input/media_reach/20160701-20170321pc_consistent.csv", index_col=[0,1])
df3=df3[["CEMP", "Origo-NWM csoport"]]
df3.columns=["CEMP","Origo csoport"]
df2.index.names=[None, None]
df3.index.names=[None, None]
df2_comp=df2.tail(21)
df3_comp=df3.head(21)
df2_comp=df2_comp.reset_index()
df3_comp=df3_comp.reset_index()
share=df2_comp[["Origo csoport"]].divide(df3_comp[["Origo csoport"]])
share=share.set_index(df2_comp.level_1)
share.index.names=[None]
a=share.groupby(share.index)["Origo csoport"].mean()
df3_reset=df3.reset_index()
df3_reset_PV=df3_reset[df3_reset.level_1=="PV"]
df3_reset_PV=df3_reset_PV[["level_0","level_1","Origo csoport"]]
df3_reset_PV["Origo csoport"]=df3_reset_PV["Origo csoport"].map(lambda x: x*a["PV"])
df3_reset_UB=df3_reset[df3_reset.level_1=="UB"]
df3_reset_UB=df3_reset_UB[["level_0","level_1","Origo csoport"]]
df3_reset_UB["Origo csoport"]=df3_reset_UB["Origo csoport"].map(lambda x: x*a["UB"])
df3_reset_RU=df3_reset[df3_reset.level_1=="RU"]
df3_reset_RU=df3_reset_RU[["level_0","level_1","Origo csoport"]]
df3_reset_RU["Origo csoport"]=df3_reset_RU["Origo csoport"].map(lambda x: x*a["RU"])
df3_reset_corrected=df3_reset_PV.append(df3_reset_RU).append(df3_reset_UB)
df3_reset_corrected_index=df3_reset_corrected.set_index(["level_0","level_1"])
df3_reset_corrected_index.index.names=[None,None]
df3["Origo csoport"]=df3_reset_corrected_index["Origo csoport"]
df3.to_csv("temp/20160701-20170321pc_consistent_adjusted.csv")


### Part 2

df2=pd.read_csv("input/media_reach/20151201-20160630pc_consistent.csv", index_col=[0,1])
#df2=df2[["CEMP", "Origo csoport"]]
df3=pd.read_csv("temp/20160701-20170321pc_consistent_adjusted.csv", index_col=[0,1])
#df3=df3[["CEMP", "Origo csoport"]]
df2.index.names=[None,None]
df3.index.names=[None,None]
after=df2.append(df3)
before=pd.read_csv("input/media_reach/20110101-20151130_consistent.csv", index_col=[0,1])
#before=before[["CEMP", "Origo csoport"]]
before.index.names=[None,None]
before_comp=before.tail(21)
after_comp=after.head(21)
before_comp=before_comp.reset_index()
after_comp=after_comp.reset_index()
share=before_comp[["CEMP","Origo csoport"]].divide(after_comp[["CEMP","Origo csoport"]])
share=share.set_index(before_comp.level_1)
a=share.groupby(share.index)["CEMP","Origo csoport"].mean()
a.index.names=[None]
a["average"]=(a.CEMP+a["Origo csoport"])/2
after_reset=after.reset_index()
after_reset_UB=after_reset[after_reset.level_1=="UB"]
after_reset_UB["Origo csoport"]=after_reset_UB["Origo csoport"].map(lambda x: x*a["average"]["UC"])
after_reset_UB["CEMP"]=after_reset_UB["CEMP"].map(lambda x: x*a["average"]["UC"])
after_reset_PV=after_reset[after_reset.level_1=="PV"]
after_reset_PV["Origo csoport"]=after_reset_PV["Origo csoport"].map(lambda x: x*a["average"]["PV"])
after_reset_PV["CEMP"]=after_reset_PV["CEMP"].map(lambda x: x*a["average"]["PV"])
after_reset_RU=after_reset[after_reset.level_1=="RU"]
after_reset_RU["Origo csoport"]=after_reset_RU["Origo csoport"].map(lambda x: x*a["average"]["RU"])
after_reset_RU["CEMP"]=after_reset_RU["CEMP"].map(lambda x: x*a["average"]["RU"])
after_reset_corrected=after_reset_PV.append(after_reset_RU).append(after_reset_UB)
after_reset_corrected_index=after_reset_corrected.set_index(["level_0","level_1"])
after_reset_corrected_index.index.names=[None,None]
after["Origo csoport"]=after_reset_corrected_index["Origo csoport"]
after["CEMP"]=after_reset_corrected_index["CEMP"]
all_data=before.append(after)
all_data.to_csv("temp/all-outlets-reader-count-pc-adjusted.csv")


### Part 3

df=pd.read_csv("temp/all-outlets-reader-count-pc-adjusted.csv", index_col=[0,1])
df.index.names=["Date","Type"]
df=df.reset_index()
df["CEMP"]=df["CEMP"].astype('float64')
df["Origo csoport"]=df["Origo csoport"].astype('float64')
df["yearmonth"]=df["Date"].map(lambda x: x[:7])
df = df.replace("-",0)
df = df.fillna(0)
for x in df.columns:
    if x!="yearmonth" and x!="Date" and x!='Type':
        df[x] = df[x].astype('float64')
df2=df.groupby(["yearmonth","Type"]).sum()
df2.index.names=[None,None]
df2.to_csv("temp/all-outlets-reader-count-pc-adjusted-monthly-sum.csv")


### Part 4
df = pd.read_csv('temp/all-outlets-reader-count-pc-adjusted-monthly-sum.csv')
df = df.rename(columns={'Unnamed: 0': 'date', 
                        'Unnamed: 1': 'measure', 
                        'CEMP': 'index', 
                        'Origo csoport': 'origo', 
                        'CM Sales': '24', 
                        'HVG Online': 'hvg'})
df = df[df['measure'] == 'RU']
df[['year', 'month']] = df['date'].str.split('-', expand=True).apply(pd.to_numeric)
df['quarter'] = (df['month'] - 1) // 3 + 1 

df2 = df[['year', 'quarter', 'index', 'origo', '24', 'hvg']].groupby(["year","quarter"]).sum().reset_index()
for x in df2.columns:
    if x != 'year' and x != 'quarter':
        df2 = df2.rename(columns={x: 'visitor_'+x})

df3 = pd.wide_to_long(df2, ['visitor'], i=['year', 'quarter'], j='media', sep='_', suffix='\w+').reset_index()
df3.loc[df3['media']=='24', 'media'] = '24.hu group'
df3.to_csv('temp/news-outlets-reader-count-pc-adjusted-quarterly-sum.csv', index=False)
