%% Counterfactual corruption exposure simulations
% Simulation of the effects of Index capture
set_n;
file_paths;
load(path_mc1)

effect_ori = zeros(N+1,3);
effect_ind = zeros(N+1,3);
effect_tot = zeros(N+1,3);
negslant = zeros(N+1,6);

fval_real = zeros(6,N+1);
fval_cf = zeros(6,N+1);

size_cont_o1 = sum((period_cont_o(:,1)==1));
size_cont_o2 = sum((period_cont_o(:,1)==2));
size_cont_o3 = sum((period_cont_o(:,1)==3));
i=1;
alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);
sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 


x0_real = [0;0.005;0.015;0;0.005;0.015];
x0_cf = x0_real;


[s_real_orig,fval_real(:,i)] = nslant_online(x0_real,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_cf_orig,fval_cf(:,i)] = nslant_online_bothcap(x0_cf,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);

s_real1=s_real_orig;
s_cf1=s_cf_orig;
s_real_orig = s_real_orig';
s_cf_orig = s_cf_orig';

corr_cf = [corr_ref_av(1:3,1);corr_ref_av(1:3,1)]-s_cf_orig';
negslant(i,:) = (corr_cf<0)';

effect_ori_aux = zeros(M,3);
effect_ind_aux = zeros(M,3);
effect_tot_aux = zeros(M,3);

for j = 1:M 
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);
sigma_sqxi_aug = sigma_sqxi/2;  
xi_resrando1_aug = xi_resrando1 - xi_resrandor;
xi_resrando2_aug = xi_resrando2 - xi_resrandor;

xi_ressimo = sqrt(sigma_sqxi_aug)*[mean(xi_resrando1_aug(1:size_cont_o1,j));mean(xi_resrando1_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando1_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j));...
          mean(xi_resrando2_aug(1:size_cont_o1,j));mean(xi_resrando2_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando2_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j))];

s_real = s_real_orig + xi_ressimo';
s_cf = s_cf_orig + xi_ressimo';

reader_sh_o = exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6))));
reader_sh_osim = exp(alpha_o*ones(1,3)+gamma*(s_cf(1,1:3)-s_cf(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf(1,1:3)-s_cf(1,4:6))));

corr_real = (reader_sh_o.*(corr_ref_av'-s_real(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_real(1,4:6)));
corr_cf = (reader_sh_o.*(corr_ref_av'-s_cf(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_cf(1,4:6)));

effect_ori_aux(j,:) = (s_real(1,1:3)-s_cf(1,1:3))./(corr_ref_av'-s_real(1,1:3));
effect_ind_aux(j,:) = (s_real(1,4:6)-s_cf(1,4:6))./(corr_ref_av'-s_real(1,4:6));
effect_tot_aux(j,:) = (corr_cf-corr_real)./corr_real;

end
effect_ori(i,:) = mean(effect_ori_aux); 
effect_ind(i,:) = mean(effect_ind_aux); 
effect_tot(i,:) = mean(effect_tot_aux); 







parfor (i = 2:N+1,40)
alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);

sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 


x0_real = s_real1;
x0_cf = s_cf1;


[s_real_orig,fval_real(:,i)] = nslant_online(x0_real,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_cf_orig,fval_cf(:,i)] = nslant_online_bothcap(x0_cf,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);


s_real_orig = s_real_orig';
s_cf_orig = s_cf_orig';

corr_cf = [corr_ref_av(1:3,1);corr_ref_av(1:3,1)]-s_cf_orig';
negslant(i,:) = (corr_cf<0)';

effect_ori_aux = zeros(M,3);
effect_ind_aux = zeros(M,3);
effect_tot_aux = zeros(M,3);

for j = 1:M 
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);
sigma_sqxi_aug = sigma_sqxi/2;  
xi_resrando1_aug = xi_resrando1 - xi_resrandor;
xi_resrando2_aug = xi_resrando2 - xi_resrandor;

xi_ressimo = sqrt(sigma_sqxi_aug)*[mean(xi_resrando1_aug(1:size_cont_o1,j));mean(xi_resrando1_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando1_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j));...

          mean(xi_resrando2_aug(1:size_cont_o1,j));mean(xi_resrando2_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando2_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j))];

s_real = s_real_orig + xi_ressimo';
s_cf = s_cf_orig + xi_ressimo';

reader_sh_o = exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6))));
reader_sh_osim = exp(alpha_o*ones(1,3)+gamma*(s_cf(1,1:3)-s_cf(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf(1,1:3)-s_cf(1,4:6))));

corr_real = (reader_sh_o.*(corr_ref_av'-s_real(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_real(1,4:6)));
corr_cf = (reader_sh_o.*(corr_ref_av'-s_cf(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_cf(1,4:6)));

effect_ori_aux(j,:) = (s_real(1,1:3)-s_cf(1,1:3))./(corr_ref_av'-s_real(1,1:3));
effect_ind_aux(j,:) = (s_real(1,4:6)-s_cf(1,4:6))./(corr_ref_av'-s_real(1,4:6));
effect_tot_aux(j,:) = (corr_cf-corr_real)./corr_real;

end
effect_ori(i,:) = mean(effect_ori_aux); 
effect_ind(i,:) = mean(effect_ind_aux); 
effect_tot(i,:) = mean(effect_tot_aux); 

end
%%
effect_ori_se = zeros(3,1);
effect_ind_se = zeros(3,1);
effect_tot_se = zeros(3,1);
effect_ori_ci = zeros(3,2);
effect_ind_ci = zeros(3,2);
effect_tot_ci = zeros(3,2);

effect_ori_p = zeros(3,1);
effect_ind_p = zeros(3,1);
effect_tot_p = zeros(3,1);
for i = 1:3
    effect_ori_se(i,1) = sqrt(var(effect_ori(2:N+1,i)));
    effect_ind_se(i,1) = sqrt(var(effect_ind(2:N+1,i)));
    effect_tot_se(i,1) = sqrt(var(effect_tot(2:N+1,i)));
    effect_ori_ci(i,:)=[quantile(effect_ori(2:N+1,i),0.05),quantile(effect_ori(2:N+1,i),0.95)];
    effect_ind_ci(i,:)=[quantile(effect_ind(2:N+1,i),0.05),quantile(effect_ind(2:N+1,i),0.95)];
    effect_tot_ci(i,:)=[quantile(effect_tot(2:N+1,i),0.05),quantile(effect_tot(2:N+1,i),0.95)];
    
    [f,x] = ecdf(effect_ori(2:N+1,i));
    effect_ori_p(i,1) = 2*(1-max((x<0).*f));

%     [f,x] = ecdf(effect_ind(2:N+1,i));
%     effect_ind_p(i,1) = 2*max((x>0).*f);
%     [f,x] = ecdf(effect_tot(2:N+1,i));
%     effect_tot_p(i,1) = 2*max((x>0).*f);
end
% Effect = [effect_ori(1,:)',effect_ori_ci,effect_ind(1,:)',effect_ind_ci,effect_tot(1,:)',effect_tot_ci];

Effect = 100*[[effect_ind(1,1),NaN,effect_ori(1,1),NaN,effect_tot(1,1),NaN];...
          [effect_ind_ci(1,1:2),effect_ori_ci(1,1:2),effect_tot_ci(1,1:2)];...
          [effect_ind(1,2),NaN,effect_ori(1,2),NaN,effect_tot(1,2),NaN];...
          [effect_ind_ci(2,1:2),effect_ori_ci(2,1:2),effect_tot_ci(2,1:2)];...
          [effect_ind(1,3),NaN,effect_ori(1,3),NaN,effect_tot(1,3),NaN];...
          [effect_ind_ci(3,1:2),effect_ori_ci(3,1:2),effect_tot_ci(3,1:2)]];


save(path_bothcap)
