%% Counterfactual corruption exposure simulations 
% Simulation of the consequences of changes in private/public budget
set_n;
file_paths;
load(path_mc1)

tic
Table = zeros(4,8);
for privat = 0:1
t = 1;
K = 2;

capture_effect = zeros(N+1,K);
capture_effect_ori = zeros(N+1,K);
capture_effect_ind = zeros(N+1,K);

Rev = zeros(N+1,K);
Rev0 = zeros(N+1,K);
Rev_mato = zeros(N+1,K);
cost = zeros(N+1,K);
cost0 = zeros(N+1,K);
cost_mato = zeros(N+1,K);
V = zeros(N+1,K);
V0 = zeros(N+1,K);
V_mato = zeros(N+1,K);

slant_ori = zeros(N+1,K); 
slant_ind = zeros(N+1,K); 
CC = zeros(N+1,K); 

profit_did = zeros(N+1,1);
budget_effect = zeros(N+1,1);
budget_effect_ori = zeros(N+1,1);
budget_effect_ind = zeros(N+1,1);

fval_cf = zeros(6,N+1);
fval_cf0 = zeros(6,N+1);
fval_cf_mato = zeros(6,N+1);

if privat == 1
points = [1,.4];
else
points = [1,2];
end
size_cont_o1 = sum((period_cont_o(:,1)==1));
size_cont_o2 = sum((period_cont_o(:,1)==2));
size_cont_o3 = sum((period_cont_o(:,1)==3));

priv = (pub_o1==0);
if privat == 1
spend_osim = kron(spend_o1,ones(1,K)).*(kron(pub_o1,ones(1,K))+kron(priv,points));
else
spend_osim = kron(spend_o1,ones(1,K)).*(kron(priv,ones(1,K))+kron(pub_o1,points));
end

pub_omat = kron(pub_o1,ones(1,K));
period_omat = kron((period_o1==t),ones(1,K));

W_P_o = sum(spend_osim.*period_omat.*pub_omat,1);
W_o = sum(spend_osim.*period_omat,1);
pub_share =  W_P_o./W_o;     
s_cf_orig1 = zeros(6,K);
s_cf0_orig1 = zeros(6,K);
s_cf_mato_orig1 = zeros(6,K);

for i = 1:N+1
alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
sigma_sqnu = solution_o(i,5);

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat_mato = [solution_o(i,14);solution_o(i,14);solution_o(i,14)];
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
s_hat_mator = s_hat_r - s_hat + s_hat_mato;
sigma_sqxi =exp(solution_o(i,19));

s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 
s_hat1_mato = s_hat_mator;
s_hat2_mato = s_hat1_mato - s_hat_mato; 

for k = 1:K
if i == 1    
x0_cf = [0;0.005;0.015;0;0;0];
x0_cf0 = [0;0.005;0.015;0;0;0];
x0_cf_mato = [0;0.005;0.015;0;0;0];
else
x0_cf = s_cf_orig1(:,k);
x0_cf0 = s_cf0_orig1(:,k);
x0_cf_mato = s_cf_mato_orig1(:,k);
end
[s_cf_orig,fval_cf(:,i)] = nslant_online(x0_cf,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_osim(:,k),pub_o1,period_o1);
[s_cf0_orig,fval_cf0(:,i)] = nslant_online(x0_cf0,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_osim(:,k),pub_o1,period_o1);
[s_cf_mato_orig,fval_cf_mato(:,i)] = nslant_online(x0_cf_mato,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_mato,beta,s_hat2_mato,sigma_sqxi,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_osim(:,k),pub_o1,period_o1);

if i == 1
    s_cf_orig1(:,k) = s_cf_orig; 
    s_cf0_orig1(:,k) = s_cf0_orig;
    s_cf_mato_orig1(:,k) = s_cf_mato_orig;
end

reader_sh_cf = exp(alpha_o+gamma*(s_cf_orig(1:3,1)-s_cf_orig(4:6,1)))./(1+exp(alpha_o+gamma*(s_cf_orig(1:3,1)-s_cf_orig(4:6,1))));
reader_sh_cf0 = exp(alpha_o+gamma*(s_cf0_orig(1:3,1)-s_cf0_orig(4:6,1)))./(1+exp(alpha_o+gamma*(s_cf0_orig(1:3,1)-s_cf0_orig(4:6,1))));
reader_sh_cf_mato = exp(alpha_o+gamma*(s_cf_mato_orig(1:3,1)-s_cf_mato_orig(4:6,1)))./(1+exp(alpha_o+gamma*(s_cf_mato_orig(1:3,1)-s_cf_mato_orig(4:6,1))));

corr_cf = (reader_sh_cf.*(corr_ref_av(1:3,1)-s_cf_orig(1:3,1))+(1-reader_sh_cf).*(corr_ref_av(1:3,1)-s_cf_orig(4:6,1))); 
corr_cf0 = (reader_sh_cf0.*(corr_ref_av(1:3,1)-s_cf0_orig(1:3,1))+(1-reader_sh_cf0).*(corr_ref_av(1:3,1)-s_cf0_orig(4:6,1))); 
corr_cf_mato = (reader_sh_cf_mato.*(corr_ref_av(1:3,1)-s_cf_mato_orig(1:3,1))+(1-reader_sh_cf_mato).*(corr_ref_av(1:3,1)-s_cf_mato_orig(4:6,1))); 

slant_ori(i,k) = s_cf_orig(t,1);
slant_ind(i,k) = s_cf_orig(t+3,1);
CC(i,k) = corr_cf(t,1);

capture_effect_ori(i,k) = (s_cf0_orig(t,1)-s_cf_mato_orig(t,1))./(corr_ref_av(t,1)-s_cf0_orig(t,1));
capture_effect_ind(i,k) = (s_cf0_orig(t+3,1)-s_cf_mato_orig(t+3,1))./(corr_ref_av(t,1)-s_cf0_orig(t+3,1));
capture_effect(i,k) = (corr_cf_mato(t,1) - corr_cf0(t,1))./corr_cf0(t,1);

adv_share_cf_aux = zeros(size_o1,M);
adv_share_cf0_aux = zeros(size_o1,M);
adv_share_cf_mato_aux = zeros(size_o1,M);

for j = 1:M    
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);
xi_resrando1_aug = xi_resrando1 - xi_resrandor;
xi_resrando2_aug = xi_resrando2 - xi_resrandor;

xi_ressimo = sqrt(sigma_sqxi/2)*[mean(xi_resrando1_aug(1:size_cont_o1,j));mean(xi_resrando1_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando1_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j));...
          mean(xi_resrando2_aug(1:size_cont_o1,j));mean(xi_resrando2_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando2_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j))];
     
s_cf = s_cf_orig+xi_ressimo;
s_cf0 = s_cf0_orig+xi_ressimo;
s_cf_mato = s_cf_mato_orig+xi_ressimo;

ladv_share = alpha_o*ones(size_o1,1)+theta_o*pub_o1+gamma*[(period_o1==1),(period_o1==2),(period_o1==3)]*(s_cf(1:3,1)-s_cf(4:6,1))+...
     delta*[(period_o1==1),(period_o1==2),(period_o1==3)]*s_cf(1:3,1).*pub_o1+lalpha_ressimo; 
ladv_share0 = alpha_o*ones(size_o1,1)+theta_o*pub_o1+gamma*[(period_o1==1),(period_o1==2),(period_o1==3)]*(s_cf0(1:3,1)-s_cf0(4:6,1))+...
    lalpha_ressimo; 
ladv_share_mato = alpha_o*ones(size_o1,1)+theta_o*pub_o1+gamma*[(period_o1==1),(period_o1==2),(period_o1==3)]*(s_cf_mato(1:3,1)-s_cf_mato(4:6,1))+...
     delta*[(period_o1==1),(period_o1==2),(period_o1==3)]*s_cf_mato(1:3,1).*pub_o1+lalpha_ressimo; 

adv_share_cf_aux(:,j) = exp(ladv_share)./(ones(size_o1,1)+exp(ladv_share));
adv_share_cf0_aux(:,j) = exp(ladv_share0)./(ones(size_o1,1)+exp(ladv_share0));
adv_share_cf_mato_aux(:,j) = exp(ladv_share_mato)./(ones(size_o1,1)+exp(ladv_share_mato));

end

revenue0 = mean(adv_share_cf0_aux,2).*spend_osim(:,k);
revenue_mato = mean(adv_share_cf_mato_aux,2).*spend_osim(:,k);

cost0(i,k) = 0.5*(s_cf0_orig(t,1)-s_hat1(t,1)).^2/(5.28*(10^-11)*beta);
cost_mato(i,k) = 0.5*(s_cf_mato_orig(t,1)-s_hat1_mato(t,1)).^2/(5.28*(10^-11)*beta);

Rev0(i,k) = sum(revenue0.*(period_o1==t));
V0(i,k)= Rev0(i,k)-cost0(i,k);

Rev_mato(i,k) = sum(revenue_mato.*(period_o1==t));
V_mato(i,k)= Rev_mato(i,k)-cost_mato(i,k);
end

profit_did(i,1) = (V_mato(i,2)-V0(i,2)-V_mato(i,1)+V0(i,1))./Rev0(i,1);  
budget_effect_ori(i,1) = (slant_ori(i,1)-slant_ori(i,2))./(corr_ref_av(t,1)-slant_ori(i,1));
budget_effect_ind(i,1) = (slant_ind(i,1)-slant_ind(i,2))./(corr_ref_av(t,1)-slant_ind(i,1));
budget_effect(i,1) = (CC(i,2)-CC(i,1))./CC(i,1);
end

capture_effect_se = zeros(K,1);
capture_effect_ci = zeros(K,2);
capture_effect_ori_se = zeros(K,1);
capture_effect_ori_ci = zeros(K,2);
capture_effect_ind_se = zeros(K,1);
capture_effect_ind_ci = zeros(K,2);

for m = 1:K
    capture_effect_se(m,1) = sqrt(var(capture_effect(2:N+1,m)));
    capture_effect_ci(m,:)=[quantile(capture_effect(2:N+1,m),0.025),quantile(capture_effect(2:N+1,m),0.975)];
    capture_effect_ori_se(m,1) = sqrt(var(capture_effect_ori(2:N+1,m)));
    capture_effect_ori_ci(m,:)=[quantile(capture_effect_ori(2:N+1,m),0.025),quantile(capture_effect_ori(2:N+1,m),0.975)];
    capture_effect_ind_se(m,1) = sqrt(var(capture_effect_ind(2:N+1,m)));
    capture_effect_ind_ci(m,:)=[quantile(capture_effect_ind(2:N+1,m),0.025),quantile(capture_effect_ind(2:N+1,m),0.975)];
end
profit_did_se = sqrt(var(profit_did(2:N+1,1)));
profit_did_ci = [quantile(profit_did(2:N+1,1),0.025),quantile(profit_did(2:N+1,1),0.975)];
budget_effect_se = sqrt(var(budget_effect(2:N+1,1)));
budget_effect_ci = [quantile(budget_effect(2:N+1,1),0.025),quantile(budget_effect(2:N+1,1),0.975)];
budget_effect_ori_se = sqrt(var(budget_effect_ori(2:N+1,1)));
budget_effect_ori_ci = [quantile(budget_effect_ori(2:N+1,1),0.025),quantile(budget_effect_ori(2:N+1,1),0.975)];
budget_effect_ind_se = sqrt(var(budget_effect_ind(2:N+1,1)));
budget_effect_ind_ci = [quantile(budget_effect_ind(2:N+1,1),0.025),quantile(budget_effect_ind(2:N+1,1),0.975)];

if privat == 1
    Table(1,:)=100*[budget_effect_ind(1,1),NaN,budget_effect_ori(1,1),NaN,profit_did(1,1),NaN,capture_effect_ori(1,2),NaN];
    Table(2,:)=100*[budget_effect_ind_ci(1,1:2),budget_effect_ori_ci(1,1:2),profit_did_ci(1,1:2),capture_effect_ori_ci(2,1:2)];
else
    Table(3,:)=100*[budget_effect_ind(1,1),NaN,budget_effect_ori(1,1),NaN,profit_did(1,1),NaN,capture_effect_ori(1,2),NaN];
    Table(4,:)=100*[budget_effect_ind_ci(1,1:2),budget_effect_ori_ci(1,1:2),profit_did_ci(1,1:2),capture_effect_ori_ci(2,1:2)];
end
end

save(path_budget)
toc
