%% Counterfactual corruption exposure simulations 
% Decomposition of the favoritism effect to incentive and selection effect
set_n;
file_paths;
load(path_mc1)

effect_toto = zeros(N+1,3);
effect_incento = zeros(N+1,3);
effect_selecto = zeros(N+1,3);
effect_incentob = zeros(N+1,3);
effect_selectob = zeros(N+1,3);
effect_sub = zeros(N+1,3);
effect_totos = zeros(N+1,3);
effect_incentos = zeros(N+1,3);
effect_selectos = zeros(N+1,3);
effect_incentosb = zeros(N+1,3);
effect_selectosb = zeros(N+1,3);
effect_subs = zeros(N+1,3);

fval_real = zeros(6,N+1);
fval_cf1 = zeros(6,N+1);
fval_cf2 = zeros(6,N+1);
fval_cf2b = zeros(6,N+1);

size_cont_o1 = sum((period_cont_o(:,1)==1));
size_cont_o2 = sum((period_cont_o(:,1)==2));
size_cont_o3 = sum((period_cont_o(:,1)==3));

i=1;
alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);
sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat_cf = [solution_o(i,13);solution_o(i,13);solution_o(i,13)];
s_hat_rcf = s_hat_r - s_hat + s_hat_cf;

s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 

s_hat1_cf = s_hat_rcf;
s_hat2_cf = s_hat1_cf - s_hat_cf; 


x0_real = [0;0.005;0.015;0;0;0];

x0_cf1 = x0_real;
x0_cf2 = x0_real;
x0_cf2b = x0_real;

[s_real_orig,fval_real(:,i)] = nslant_online(x0_real,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_cf1_orig,fval_cf1(:,i)] = nslant_online(x0_cf1,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_cf,beta,s_hat2_cf,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1); 
[s_cf2_orig,fval_cf2(:,i)] = nslant_online(x0_cf2,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_cf,beta,s_hat2_cf,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1); 
[s_cf2b_orig,fval_cf2b(:,i)] = nslant_online(x0_cf2b,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
 
s_real_orig = s_real_orig';
s_cf1_orig = s_cf1_orig';
s_cf2_orig = s_cf2_orig';
s_cf2b_orig = s_cf2b_orig';

s_real1=s_real_orig;
s_cf11=s_cf1_orig;
s_cf21=s_cf2_orig;
s_cf2b1=s_cf2b_orig;
xi_est = [s_emp(1:3,1);s_emp(1:3,2)]'- s_real_orig; 


s_real = s_real_orig + xi_est;
s_cf1 = s_cf1_orig + xi_est;
s_cf2 = s_cf2_orig + xi_est;
s_cf2b = s_cf2b_orig + xi_est;

reader_sh_o = exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3))-s_real(1,4:6)));
reader_sh_o1 = exp(alpha_o*ones(1,3)+gamma*(s_cf1(1,1:3)-s_cf1(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf1(1,1:3))-s_cf1(1,4:6)));
reader_sh_o2 = exp(alpha_o*ones(1,3)+gamma*(s_cf2(1,1:3)-s_cf2(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf2(1,1:3))-s_cf2(1,4:6)));
reader_sh_o2b = exp(alpha_o*ones(1,3)+gamma*(s_cf2b(1,1:3)-s_cf2b(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf2b(1,1:3))-s_cf2b(1,4:6)));


corr_real = (reader_sh_o.*(corr_ref_av'-s_real(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_real(1,4:6)));
corr_1 = (reader_sh_o1.*(corr_ref_av'-s_cf1(1,1:3))+(ones(1,3)-reader_sh_o1).*(corr_ref_av'-s_cf1(1,4:6)));
corr_2 = (reader_sh_o2.*(corr_ref_av'-s_cf2(1,1:3))+(ones(1,3)-reader_sh_o2).*(corr_ref_av'-s_cf2(1,4:6)));
corr_2b = (reader_sh_o2b.*(corr_ref_av'-s_cf2b(1,1:3))+(ones(1,3)-reader_sh_o2b).*(corr_ref_av'-s_cf2b(1,4:6)));

effect_toto(i,:)= -(corr_1-corr_real)./corr_1;
effect_incento(i,:)= (corr_2-corr_1)./corr_1;
effect_selecto(i,:) = effect_toto(i,:) - effect_incento(i,:); 
effect_selectob(i,:) = (corr_2b-corr_1)./corr_1;
effect_incentob(i,:) = effect_toto(i,:) - effect_selectob(i,:);

effect_totos(i,:) = -(s_real(1,1:3)-s_cf1(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_incentos(i,:) = -(s_cf2(1,1:3)-s_cf1(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_selectos(i,:) = effect_totos(i,:) - effect_incentos(i,:);
effect_selectosb(i,:) = (s_cf1(1,1:3)-s_cf2b(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_incentosb(i,:) = effect_totos(i,:) - effect_selectosb(i,:);

effect_sub(i,:) = effect_toto(i,:)-effect_incento(i,:)-effect_selectob(i,:);
effect_subs(i,:) = effect_totos(i,:)-effect_incentos(i,:)-effect_selectosb(i,:);



parfor (i = 2:N+1, 40)
alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);
sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat_cf = [solution_o(i,13);solution_o(i,13);solution_o(i,13)];
s_hat_rcf = s_hat_r - s_hat + s_hat_cf;

s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 

s_hat1_cf = s_hat_rcf;
s_hat2_cf = s_hat1_cf - s_hat_cf; 

x0_real = s_real1';
x0_cf1 = s_cf11';
x0_cf2 = s_cf21';
x0_cf2b = s_cf2b1';    

[s_real_orig,fval_real(:,i)] = nslant_online(x0_real,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_cf1_orig,fval_cf1(:,i)] = nslant_online(x0_cf1,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_cf,beta,s_hat2_cf,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1); 
[s_cf2_orig,fval_cf2(:,i)] = nslant_online(x0_cf2,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_cf,beta,s_hat2_cf,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1); 
[s_cf2b_orig,fval_cf2b(:,i)] = nslant_online(x0_cf2b,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1,beta,s_hat2,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
 
s_real_orig = s_real_orig';
s_cf1_orig = s_cf1_orig';
s_cf2_orig = s_cf2_orig';
s_cf2b_orig = s_cf2b_orig';


s_real = s_real_orig + xi_est;
s_cf1 = s_cf1_orig + xi_est;
s_cf2 = s_cf2_orig + xi_est;
s_cf2b = s_cf2b_orig + xi_est;

reader_sh_o = exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3)-s_real(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_real(1,1:3))-s_real(1,4:6)));
reader_sh_o1 = exp(alpha_o*ones(1,3)+gamma*(s_cf1(1,1:3)-s_cf1(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf1(1,1:3))-s_cf1(1,4:6)));
reader_sh_o2 = exp(alpha_o*ones(1,3)+gamma*(s_cf2(1,1:3)-s_cf2(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf2(1,1:3))-s_cf2(1,4:6)));
reader_sh_o2b = exp(alpha_o*ones(1,3)+gamma*(s_cf2b(1,1:3)-s_cf2b(1,4:6)))./(ones(1,3)+exp(alpha_o*ones(1,3)+gamma*(s_cf2b(1,1:3))-s_cf2b(1,4:6)));

corr_real = (reader_sh_o.*(corr_ref_av'-s_real(1,1:3))+(ones(1,3)-reader_sh_o).*(corr_ref_av'-s_real(1,4:6)));
corr_1 = (reader_sh_o1.*(corr_ref_av'-s_cf1(1,1:3))+(ones(1,3)-reader_sh_o1).*(corr_ref_av'-s_cf1(1,4:6)));
corr_2 = (reader_sh_o2.*(corr_ref_av'-s_cf2(1,1:3))+(ones(1,3)-reader_sh_o2).*(corr_ref_av'-s_cf2(1,4:6)));
corr_2b = (reader_sh_o2b.*(corr_ref_av'-s_cf2b(1,1:3))+(ones(1,3)-reader_sh_o2b).*(corr_ref_av'-s_cf2b(1,4:6)));

effect_toto(i,:)= -(corr_1-corr_real)./corr_1;
effect_incento(i,:)= (corr_2-corr_1)./corr_1;
effect_selecto(i,:) = effect_toto(i,:) - effect_incento(i,:); 
effect_selectob(i,:) = (corr_2b-corr_1)./corr_1;
effect_incentob(i,:) = effect_toto(i,:) - effect_selectob(i,:);

effect_totos(i,:) = -(s_real(1,1:3)-s_cf1(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_incentos(i,:) = -(s_cf2(1,1:3)-s_cf1(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_selectos(i,:) = effect_totos(i,:) - effect_incentos(i,:);
effect_selectosb(i,:) = (s_cf1(1,1:3)-s_cf2b(1,1:3))./(corr_ref_av'-s_cf1(1,1:3));
effect_incentosb(i,:) = effect_totos(i,:) - effect_selectosb(i,:);

effect_sub(i,:) = effect_toto(i,:)-effect_incento(i,:)-effect_selectob(i,:);
effect_subs(i,:) = effect_totos(i,:)-effect_incentos(i,:)-effect_selectosb(i,:);
end


effect_toto_se = zeros(3,1);
effect_incento_se = zeros(3,1);
effect_selecto_se = zeros(3,1);
effect_incentob_se = zeros(3,1);
effect_selectob_se = zeros(3,1);
effect_toto_ci = zeros(3,2);
effect_incento_ci = zeros(3,2);
effect_selecto_ci = zeros(3,2);
effect_incentob_ci = zeros(3,2);
effect_selectob_ci = zeros(3,2);

effect_totos_se = zeros(3,1);
effect_incentos_se = zeros(3,1);
effect_selectos_se = zeros(3,1);
effect_incentosb_se = zeros(3,1);
effect_selectosb_se = zeros(3,1);
effect_totos_ci = zeros(3,2);
effect_incentos_ci = zeros(3,2);
effect_selectos_ci = zeros(3,2);
effect_incentosb_ci = zeros(3,2);
effect_selectosb_ci = zeros(3,2);

effect_sub_se = zeros(3,1);
effect_sub_ci = zeros(3,2);
effect_subs_se = zeros(3,1);
effect_subs_ci = zeros(3,2);


for i = 1:3
    effect_toto_se(i,1) = sqrt(var(effect_toto(2:N+1,i)));
    effect_incento_se(i,1) = sqrt(var(effect_incento(2:N+1,i)));
    effect_selecto_se(i,1) = sqrt(var(effect_selecto(2:N+1,i)));
    effect_incentob_se(i,1) = sqrt(var(effect_incentob(2:N+1,i)));
    effect_selectob_se(i,1) = sqrt(var(effect_selectob(2:N+1,i)));
    effect_toto_ci(i,:)=[quantile(effect_toto(2:N+1,i),0.025),quantile(effect_toto(2:N+1,i),0.975)];
    effect_incento_ci(i,:)=[quantile(effect_incento(2:N+1,i),0.025),quantile(effect_incento(2:N+1,i),0.975)];
    effect_selecto_ci(i,:)=[quantile(effect_selecto(2:N+1,i),0.025),quantile(effect_selecto(2:N+1,i),0.975)];
    effect_incentob_ci(i,:)=[quantile(effect_incentob(2:N+1,i),0.025),quantile(effect_incentob(2:N+1,i),0.975)];
    effect_selectob_ci(i,:)=[quantile(effect_selectob(2:N+1,i),0.025),quantile(effect_selectob(2:N+1,i),0.975)];
    
    effect_totos_se(i,1) = sqrt(var(effect_totos(2:N+1,i)));
    effect_incentos_se(i,1) = sqrt(var(effect_incentos(2:N+1,i)));
    effect_selectos_se(i,1) = sqrt(var(effect_selectos(2:N+1,i)));
    effect_incentosb_se(i,1) = sqrt(var(effect_incentosb(2:N+1,i)));
    effect_selectosb_se(i,1) = sqrt(var(effect_selectosb(2:N+1,i)));
    effect_totos_ci(i,:)=[quantile(effect_totos(2:N+1,i),0.025),quantile(effect_totos(2:N+1,i),0.975)];
    effect_incentos_ci(i,:)=[quantile(effect_incentos(2:N+1,i),0.025),quantile(effect_incentos(2:N+1,i),0.975)];
    effect_selectos_ci(i,:)=[quantile(effect_selectos(2:N+1,i),0.025),quantile(effect_selectos(2:N+1,i),0.975)];
    effect_incentosb_ci(i,:)=[quantile(effect_incentosb(2:N+1,i),0.025),quantile(effect_incentosb(2:N+1,i),0.975)];
    effect_selectosb_ci(i,:)=[quantile(effect_selectosb(2:N+1,i),0.025),quantile(effect_selectosb(2:N+1,i),0.975)];
    
    effect_sub_se(i,1) = sqrt(var(effect_sub(2:N+1,i)));
    effect_subs_se(i,1) = sqrt(var(effect_subs(2:N+1,i)));
    effect_sub_ci(i,:) = [quantile(effect_sub(2:N+1,i),0.025),quantile(effect_sub(2:N+1,i),0.975)];
    effect_subs_ci(i,:) = [quantile(effect_subs(2:N+1,i),0.025),quantile(effect_subs(2:N+1,i),0.975)];
end
       
Decomp = 100*[effect_toto(1,1),NaN,effect_selectob(1,1),NaN,effect_incento(1,1),NaN,effect_sub(1,1),NaN,effect_totos(1,1),NaN,effect_selectosb(1,1),NaN,effect_incentos(1,1),NaN,effect_subs(1,1),NaN;...
          effect_toto_ci(1,1:2),effect_selectob_ci(1,1:2),effect_incento_ci(1,1:2),effect_sub_ci(1,1:2),effect_totos_ci(1,1:2),effect_selectosb_ci(1,1:2),effect_incentos_ci(1,1:2),effect_subs_ci(1,1:2);...
          effect_toto(1,2),NaN,effect_selectob(1,2),NaN,effect_incento(1,2),NaN,effect_sub(1,2),NaN,effect_totos(1,2),NaN,effect_selectosb(1,2),NaN,effect_incentos(1,2),NaN,effect_subs(1,2),NaN;...
          effect_toto_ci(2,1:2),effect_selectob_ci(2,1:2),effect_incento_ci(2,1:2),effect_sub_ci(2,1:2),effect_totos_ci(2,1:2),effect_selectosb_ci(2,1:2),effect_incentos_ci(2,1:2),effect_subs_ci(2,1:2);...
          effect_toto(1,3),NaN,effect_selectob(1,3),NaN,effect_incento(1,3),NaN,effect_sub(1,3),NaN,effect_totos(1,3),NaN,effect_selectosb(1,3),NaN,effect_incentos(1,3),NaN,effect_subs(1,3),NaN;...
          effect_toto_ci(3,1:2),effect_selectob_ci(3,1:2),effect_incento_ci(3,1:2),effect_sub_ci(3,1:2),effect_totos_ci(3,1:2),effect_selectosb_ci(3,1:2),effect_incentos_ci(3,1:2),effect_subs_ci(3,1:2)];         
          
    
save(path_decomp)


% plot_corr1 = corr_refo-slant_own_o;
% plot_corr2 = plot_corr1+[(period_cont_o0==1),(period_cont_o0==2),(period_cont_o0==3)]*(s_real1(1,1:3)'-s_cf11(1,1:3)');
% plot_corr3 = plot_corr1+[(period_cont_o0==1),(period_cont_o0==2),(period_cont_o0==3)]*(s_real1(1,1:3)'-s_cf21(1,1:3)');
% plot_corr4 = corr_refo-slant_other_o;
% 
% % time = [1:1:48]';
% hold on
% plot(time,plot_corr1,'r',time,plot_corr2,'r--',time,plot_corr3,'r:',time,plot_corr4,'b')
% plot([15 15],[0 0.04],'g','LineWidth',1.5)
% plot([34 34],[0 0.04],'g','LineWidth',1.5)
% legend({'Captured, actual', 'Captured, full','Captured, selection','Uncaptured, actual'},'Location','northwest','FontSize', 10)
% print -dpdf content_sim.pdf 
