clear all
pause on
set more off


*******************
*** START *********
*******************

import delimited "input/media_analysis/media_analysis_results.csv", encoding(UTF-8) clear

split date, p("_")
destring date1, gen(year)
destring date2, gen(month)
drop date*





*** FIND LAST time WHEN NOL EXISTS
*** Set start and and dates based on DATES and not TIME
drop if year < 2010 | year > 2016 | (year == 2016 & month > 10 )
*drop if year < 2010 | year > 2016 | (year == 2016 & month > 7 )
*drop if year < 2010
keep if inlist(page, "MNO", "NOL", "MH")




egen time=group(year month)
tab time, gen(dtime)
drop dtime55

order page year month time

egen media=group(page)
gen corr_share=any/all*100

gen mno = page == "MNO"
gen nol = page == "NOL"
gen mh  = page == "MH"

gen post = year > 2015 | (year == 2015 & month >= 3)
gen post_mno = post * mno
gen post_nol = post * nol

twoway connected corr_share time if page=="NOL" & time >= 37, sort(time) lcolor(blue) mcolor(blue) lpattern(dash) msymbol(d) || ///
	   connected corr_share time if page=="MNO" & time >= 37, sort(time) lcolor(red) mcolor(red) lwidth(thick) msymbol(0) || ///
	   connected corr_share time if page=="MH"  & time >= 37, sort(time) lcolor(black) mcolor(black) msymbol(T) lpattern(dash_dot) ///
			tline(62, lwidth(thick) lcolor("green")) ///
			legend( label(1 Left-wing daily) label(2 Affected right-wing daily) label(3 Unaffected right-wing daily))  ///
			xtitle("Date") ytitle("%") /*title("Share of articles covering government corruption")*/ ///
			/*xlabel(43 "July 2013" 49 "Jan 2014" 55 "July 2014" 61 "Jan 2015" 67 "July 2015" 73 "Jan 2016" 79 "July 2016")*/ ///
			xlabel(37 "Jan 2013" 49 "Jan 2014" 61 "Jan 2015" 73 "Jan 2016") ///
			graphregion(color(white)) plotregion(m(tiny))
graph export "output/figure5.pdf", as(pdf) replace