clear all
pause on
set more off


*******************
*** START *********
*******************

import delimited "input/media_analysis/media_analysis_results.csv", encoding(UTF-8) clear

split date, p("_")
destring date1, gen(year)
destring date2, gen(month)
drop date*

keep if inlist(page, "INDEX", "ORIGO")
*drop if year < 2012 | (year == 2018 & month >= 8)
*drop if year < 2013 | year > 2016 | (year == 2016 & month == 12)
drop if year < 2012 | year > 2016 | (year == 2016 & month > 10 )



egen time=group(year month)
tab time, gen(dtime)
drop dtime1

order page year month time

gen corr_share=any/all*100


gen origo = (page=="ORIGO")
gen period2 = (time>=31&time<49)
gen period3 = (time>=49)
gen origo_p2 = origo*period2
gen origo_p3 = origo*period3

twoway connected corr_share time if page=="INDEX" & time >= 13, sort(time) lcolor(blue) mcolor(blue) lpattern(dash) msymbol(d) || ///
	   connected corr_share time if page=="ORIGO" & time >= 13, sort(time) lcolor(red) mcolor(red) /*lwidth(thick)*/ msymbol(0) ///
			legend( label(1 Index) label(2 Origo)) xli(32 49, lwidth(thick) lcolor("green")) ///
			xtitle("Date") ytitle("%") /*title("Share of articles covering government corruption")*/ ///
			xlabel(13 "Jan 2013" 32 "change of editor" 49 "change of owner") /// 
			graphregion(color(white)) plotregion(m(tiny))
graph export "output/figure6.pdf", as(pdf) replace