clear all
pause on


*******************
*** START *********
*******************

use "temp/aux3_largest_do_vege_print.dta", clear
append using "temp/aux3_largest_do_vege_online.dta"
append using "temp/aux3_largest_do_vege_tv.dta"
drop if type==5 & (education==1 | health==1 | culture==1)  

gen period = .
replace period=1 if year==2013|(year==2014&month<6)
replace period=2 if (year==2014&month>=6)|(year==2015)
replace period=3 if year>=2016
drop if period == .

gen type3 =.
replace type3 = 1 if type==1|type==2
replace type3 = 2 if type==3|type==5
drop if type3 ==.

/*
foreach X in base all{
	foreach Y in included excluded{
		preserve

			if "`X'" == "base"{
				drop if mediatype == "KÁBELTELEVÍZIÓ"
			} 

			if "`Y'" == "excluded"{
				drop if inlist(media, "M1", "M2", "PETŐFI TV", "M4 SPORT", "M5", "DUNA TV") 
			} 
	
			collapse (sum) spending, by(period market type3)
			sort market type3 period

			egen spending_total = total(spending), by(period market)
			gen spending_share = spending/spending_total

			gen spending_share_1_aux = spending_share*(period==1)
			egen spending_share_1 = max(spending_share_1_aux), by(market type3)
			gen spending_trend = spending_share/spending_share_1


			twoway connected spending_trend period if market=="online" & type3==2, sort(period) mcolor(red) lcolor(red) msymbol(O)  || ///
				   connected spending_trend period if market=="print"  & type3==2, sort(period) mcolor(blue) lcolor(blue) msymbol(T) ||  ///
				   connected spending_trend period if market=="tv"     & type3==2, sort(period) mcolor(black) lcolor(black) msymbol(d) ///
						legend(label(1 Online) label(2 Printed) label(3 Televison) order(1 2 3)) xtitle("Period") ytitle("Share of public spending") ///
						yscale(r(.9 1.5)) xlabel( 1 "1" 2 "2" 3 "3") graphregion(color(white)) plotregion(m(tiny)) ///
						title("`X' channels, public `Y'")
			graph export "output/similar_trend_`X'_`Y'.pdf", as(pdf) replace
		
		restore
	}
}
*/

drop if inlist(media, "M1", "M2", "PETŐFI TV", "M4 SPORT", "M5", "DUNA TV") 
collapse (sum) spending, by(period market type3)
sort market type3 period

egen spending_total = total(spending), by(period market)
gen spending_share = spending/spending_total

gen spending_share_1_aux = spending_share*(period==1)
egen spending_share_1 = max(spending_share_1_aux), by(market type3)
gen spending_trend = spending_share/spending_share_1


twoway connected spending_trend period if market=="online" & type3==2, sort(period) mcolor(red) lcolor(red) msymbol(O)  || ///
	   connected spending_trend period if market=="print"  & type3==2, sort(period) mcolor(blue) lcolor(blue) msymbol(T) ||  ///
	   connected spending_trend period if market=="tv"     & type3==2, sort(period) mcolor(black) lcolor(black) msymbol(d) ///
			legend(label(1 Online) label(2 Printed) label(3 Televison) order(1 2 3)) xtitle("Period") ytitle("Share of public spending") ///
			yscale(r(.9 1.5)) xlabel( 1 "1" 2 "2" 3 "3") graphregion(color(white)) plotregion(m(tiny))
graph export "output/figureA1.pdf", as(pdf) replace




