%% Counterfactual corruption exposure simulations 
% Simulation of Origo profits under different owners
set_n;
file_paths;
load(path_mc1)

V_tcom0 = zeros(3,N+1);
V_mato0 = zeros(3,N+1);
V_tcom = zeros(3,N+1);
V_mato = zeros(3,N+1);

Rev_tcom = zeros(3,N+1);
Rev_tcom0 = zeros(3,N+1);
Rev_mato = zeros(3,N+1);
Rev_mato0 = zeros(3,N+1);
cost_mato = zeros(3,N+1);
cost_mato0 = zeros(3,N+1);

profit_gap0 = zeros(3,N+1);
profit_gap = zeros(3,N+1);
profit_gap_d = zeros(3,N+1);
profit_gap_did = zeros(1,N+1);

fval_tcom0 = zeros(6,N+1);
fval_tcom = zeros(6,N+1);
fval_mato = zeros(6,N+1);
fval_mato0 = zeros(6,N+1);

size_cont_o1 = sum((period_cont_o(:,1)==1));
size_cont_o2 = sum((period_cont_o(:,1)==2));
size_cont_o3 = sum((period_cont_o(:,1)==3));

size_o1 = sum((period_o1==1));
size_o2 = sum((period_o1==2));
size_o3 = sum((period_o1==3));
size_o = size_o1 + size_o2 + size_o3;

i=1;

alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);
sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat_tcom = [solution_o(i,13);solution_o(i,13);solution_o(i,13)];

s_hat_mato = [solution_o(i,14);solution_o(i,14);solution_o(i,14)];
s_hat_tcomr = s_hat_r - s_hat + s_hat_tcom;
s_hat_mator = s_hat_r - s_hat + s_hat_mato;

s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 
 
s_hat1_tcom = s_hat_tcomr;
s_hat2_tcom = s_hat1_tcom - s_hat_tcom; 

s_hat1_mato = s_hat_mator;
s_hat2_mato = s_hat1_mato - s_hat_mato; 

x0_tcom = [0;0.005;0.015;0;0;0];
x0_tcom0 = x0_tcom;
x0_mato = x0_tcom;
x0_mato0 = x0_tcom;    

[s_tcom0_orig,fval_tcom0(:,i)] = nslant_online(x0_tcom0,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_tcom,beta,s_hat2_tcom,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);

[s_mato0_orig,fval_mato0(:,i)] = nslant_online(x0_mato0,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_mato,beta,s_hat2_mato,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_tcom_orig,fval_tcom(:,i)] = nslant_online(x0_tcom,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_tcom,beta,s_hat2_tcom,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_mato_orig,fval_mato(:,i)] = nslant_online(x0_mato,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_mato,beta,s_hat2_mato,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
s_tcom0_orig = s_tcom0_orig';
s_tcom_orig = s_tcom_orig';
s_mato0_orig = s_mato0_orig';
s_mato_orig = s_mato_orig';


s_tcom01 = s_tcom0_orig;
s_tcom1 = s_tcom_orig;
s_mato01 = s_mato0_orig;
s_mato1 = s_mato_orig;


adv_share_tcom0 = zeros(size_o,M);
adv_share_tcom = zeros(size_o,M);
adv_share_mato0 = zeros(size_o,M);
adv_share_mato = zeros(size_o,M);

for j = 1:M 
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);

xi_resrando1_aug = xi_resrando1 - xi_resrandor;
xi_resrando2_aug = xi_resrando2 - xi_resrandor;

xi_ressimo = sqrt(sigma_sqxi/2)*[mean(xi_resrando1_aug(1:size_cont_o1,j));mean(xi_resrando1_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando1_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j));...
          mean(xi_resrando2_aug(1:size_cont_o1,j));mean(xi_resrando2_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando2_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j))];

s_tcom0 = s_tcom0_orig + xi_ressimo';
s_mato0 = s_mato0_orig + xi_ressimo';
s_tcom = s_tcom_orig + xi_ressimo';
s_mato = s_mato_orig + xi_ressimo';

slant_tcom0_diff = [(s_tcom0(1,1)-s_tcom0(1,4))*ones(size_o1,1);(s_tcom0(1,2)-s_tcom0(1,5))*ones(size_o2,1);(s_tcom0(1,3)-s_tcom0(1,6))*ones(size_o3,1)];
lalpha_tcom0 = alpha_o*ones(size_o,1) + gamma*slant_tcom0_diff + theta_o*pub_o1 + lalpha_ressimo;
adv_share_tcom0(:,j) = exp(lalpha_tcom0)./(ones(size_o,1)+exp(lalpha_tcom0));

slant_mato0_diff = [(s_mato0(1,1)-s_mato0(1,4))*ones(size_o1,1);(s_mato0(1,2)-s_mato0(1,5))*ones(size_o2,1);(s_mato0(1,3)-s_mato0(1,6))*ones(size_o3,1)];

lalpha_mato0 = alpha_o*ones(size_o,1) + gamma*slant_mato0_diff + theta_o*pub_o1 + lalpha_ressimo;
adv_share_mato0(:,j) = exp(lalpha_mato0)./(ones(size_o,1)+exp(lalpha_mato0));

slant_tcom_diff = [(s_tcom(1,1)-s_tcom(1,4))*ones(size_o1,1);(s_tcom(1,2)-s_tcom(1,5))*ones(size_o2,1);(s_tcom(1,3)-s_tcom(1,6))*ones(size_o3,1)];
slant_tcom_own = [s_tcom(1,1)*ones(size_o1,1);s_tcom(1,2)*ones(size_o2,1);s_tcom(1,3)*ones(size_o3,1)];
lalpha_tcom = alpha_o*ones(size_o,1) + gamma*slant_tcom_diff + theta_o*pub_o1 + delta*pub_o1.*slant_tcom_own + lalpha_ressimo;
adv_share_tcom(:,j) = exp(lalpha_tcom)./(ones(size_o,1)+exp(lalpha_tcom));

slant_mato_diff = [(s_mato(1,1)-s_mato(1,4))*ones(size_o1,1);(s_mato(1,2)-s_mato(1,5))*ones(size_o2,1);(s_mato(1,3)-s_mato(1,6))*ones(size_o3,1)];
slant_mato_own = [s_mato(1,1)*ones(size_o1,1);s_mato(1,2)*ones(size_o2,1);s_mato(1,3)*ones(size_o3,1)];
lalpha_mato = alpha_o*ones(size_o,1) + gamma*slant_mato_diff + theta_o*pub_o1 + delta*pub_o1.*slant_mato_own + lalpha_ressimo;
adv_share_mato(:,j) = exp(lalpha_mato)./(ones(size_o,1)+exp(lalpha_mato));

end
revenue_tcom0 = mean(adv_share_tcom0,2).*spend_o1;
revenue_mato0 = mean(adv_share_mato0,2).*spend_o1;
revenue_tcom = mean(adv_share_tcom,2).*spend_o1;
revenue_mato = mean(adv_share_mato,2).*spend_o1;

cost_tcom0 = 0.5*(s_tcom0_orig(1,1:3)'-s_hat1_tcom).^2/(5.28*(10^-11)*beta);
cost_tcom = 0.5*(s_tcom_orig(1,1:3)'-s_hat1_tcom).^2/(5.28*(10^-11)*beta);
cost_mato0(:,i) = 0.5*(s_mato0_orig(1,1:3)'-s_hat1_mato).^2/(5.28*(10^-11)*beta);
cost_mato(:,i) = 0.5*(s_mato_orig(1,1:3)'-s_hat1_mato).^2/(5.28*(10^-11)*beta);

Rev_tcom0(:,i) = [sum(revenue_tcom0(period_o1==1));sum(revenue_tcom0(period_o1==2));...
    sum(revenue_tcom0(period_o1==3))];
V_tcom0(:,i)= Rev_tcom0(:,i)-cost_tcom0;

Rev_mato0(:,i) = [sum(revenue_mato0(period_o1==1));sum(revenue_mato0(period_o1==2));...
    sum(revenue_mato0(period_o1==3))];
V_mato0(:,i)= Rev_mato0(:,i)-cost_tcom;

Rev_tcom(:,i) = [sum(revenue_tcom(period_o1==1));sum(revenue_tcom(period_o1==2));...
    sum(revenue_tcom(period_o1==3))];

V_tcom(:,i)= Rev_tcom(:,i)-cost_mato0(:,i);

Rev_mato(:,i) = [sum(revenue_mato(period_o1==1));sum(revenue_mato(period_o1==2));...
    sum(revenue_mato(period_o1==3))];
V_mato(:,i)= Rev_mato(:,i)-cost_mato(:,i);

profit_gap0(:,i) = (V_mato0(:,i)-V_tcom0(:,i))./Rev_tcom0(:,i);
profit_gap(:,i) = (V_mato(:,i)-V_tcom(:,i))./Rev_tcom0(:,i);
profit_gap_d(:,i) = profit_gap0(:,i) - profit_gap(:,i);
profit_gap_did(:,i) = profit_gap_d(3,i) - profit_gap_d(1,i);





parfor (i = 2:N+1, 40)

alpha_o = solution_o(i,1);
theta_o = solution_o(i,2);
gamma = solution_o(i,3);
delta = solution_o(i,4);
beta = solution_o(i,15);
s_hat_r = solution_o(i,16:18)';
sigma_sqnu = solution_o(i,5);
sigma_sqxi = exp(solution_o(i,19));

s_hat = [solution_o(i,13);solution_o(i,13);solution_o(i,14)];
s_hat_tcom = [solution_o(i,13);solution_o(i,13);solution_o(i,13)];
s_hat_mato = [solution_o(i,14);solution_o(i,14);solution_o(i,14)];
s_hat_tcomr = s_hat_r - s_hat + s_hat_tcom;
s_hat_mator = s_hat_r - s_hat + s_hat_mato;

s_hat1 = s_hat_r;
s_hat2 = s_hat1 - s_hat; 
 
s_hat1_tcom = s_hat_tcomr;
s_hat2_tcom = s_hat1_tcom - s_hat_tcom; 

s_hat1_mato = s_hat_mator;
s_hat2_mato = s_hat1_mato - s_hat_mato; 

 
x0_tcom = s_tcom1';
x0_tcom0 = s_tcom01';
x0_mato = s_mato1';
x0_mato0 = s_mato01';
  

[s_tcom0_orig,fval_tcom0(:,i)] = nslant_online(x0_tcom0,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_tcom,beta,s_hat2_tcom,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_mato0_orig,fval_mato0(:,i)] = nslant_online(x0_mato0,alpha_o,theta_o,gamma,0,sigma_sqnu,s_hat1_mato,beta,s_hat2_mato,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_tcom_orig,fval_tcom(:,i)] = nslant_online(x0_tcom,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_tcom,beta,s_hat2_tcom,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
[s_mato_orig,fval_mato(:,i)] = nslant_online(x0_mato,alpha_o,theta_o,gamma,delta,sigma_sqnu,s_hat1_mato,beta,s_hat2_mato,sigma_sqxi,lalpha_resrando,...
     xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1);
s_tcom0_orig = s_tcom0_orig';
s_tcom_orig = s_tcom_orig';
s_mato0_orig = s_mato0_orig';
s_mato_orig = s_mato_orig';


adv_share_tcom0 = zeros(size_o,M);
adv_share_tcom = zeros(size_o,M);
adv_share_mato0 = zeros(size_o,M);
adv_share_mato = zeros(size_o,M);

for j = 1:M 
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);

xi_resrando1_aug = xi_resrando1 - xi_resrandor;
xi_resrando2_aug = xi_resrando2 - xi_resrandor;

xi_ressimo = sqrt(sigma_sqxi/2)*[mean(xi_resrando1_aug(1:size_cont_o1,j));mean(xi_resrando1_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando1_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j));...
          mean(xi_resrando2_aug(1:size_cont_o1,j));mean(xi_resrando2_aug(1+size_cont_o1:size_cont_o1+size_cont_o2,j));...
          mean(xi_resrando2_aug(1+size_cont_o1+size_cont_o2:size_cont_o1+size_cont_o2+size_cont_o3,j))];

s_tcom0 = s_tcom0_orig + xi_ressimo';
s_mato0 = s_mato0_orig + xi_ressimo';
s_tcom = s_tcom_orig + xi_ressimo';
s_mato = s_mato_orig + xi_ressimo';

slant_tcom0_diff = [(s_tcom0(1,1)-s_tcom0(1,4))*ones(size_o1,1);(s_tcom0(1,2)-s_tcom0(1,5))*ones(size_o2,1);(s_tcom0(1,3)-s_tcom0(1,6))*ones(size_o3,1)];
lalpha_tcom0 = alpha_o*ones(size_o,1) + gamma*slant_tcom0_diff + theta_o*pub_o1 + lalpha_ressimo;
adv_share_tcom0(:,j) = exp(lalpha_tcom0)./(ones(size_o,1)+exp(lalpha_tcom0));

slant_mato0_diff = [(s_mato0(1,1)-s_mato0(1,4))*ones(size_o1,1);(s_mato0(1,2)-s_mato0(1,5))*ones(size_o2,1);(s_mato0(1,3)-s_mato0(1,6))*ones(size_o3,1)];
lalpha_mato0 = alpha_o*ones(size_o,1) + gamma*slant_mato0_diff + theta_o*pub_o1 + lalpha_ressimo;
adv_share_mato0(:,j) = exp(lalpha_mato0)./(ones(size_o,1)+exp(lalpha_mato0));

slant_tcom_diff = [(s_tcom(1,1)-s_tcom(1,4))*ones(size_o1,1);(s_tcom(1,2)-s_tcom(1,5))*ones(size_o2,1);(s_tcom(1,3)-s_tcom(1,6))*ones(size_o3,1)];
slant_tcom_own = [s_tcom(1,1)*ones(size_o1,1);s_tcom(1,2)*ones(size_o2,1);s_tcom(1,3)*ones(size_o3,1)];
lalpha_tcom = alpha_o*ones(size_o,1) + gamma*slant_tcom_diff + theta_o*pub_o1 + delta*pub_o1.*slant_tcom_own + lalpha_ressimo;
adv_share_tcom(:,j) = exp(lalpha_tcom)./(ones(size_o,1)+exp(lalpha_tcom));

slant_mato_diff = [(s_mato(1,1)-s_mato(1,4))*ones(size_o1,1);(s_mato(1,2)-s_mato(1,5))*ones(size_o2,1);(s_mato(1,3)-s_mato(1,6))*ones(size_o3,1)];
slant_mato_own = [s_mato(1,1)*ones(size_o1,1);s_mato(1,2)*ones(size_o2,1);s_mato(1,3)*ones(size_o3,1)];
lalpha_mato = alpha_o*ones(size_o,1) + gamma*slant_mato_diff + theta_o*pub_o1 + delta*pub_o1.*slant_mato_own + lalpha_ressimo;
adv_share_mato(:,j) = exp(lalpha_mato)./(ones(size_o,1)+exp(lalpha_mato));

end
revenue_tcom0 = mean(adv_share_tcom0,2).*spend_o1;
revenue_mato0 = mean(adv_share_mato0,2).*spend_o1;
revenue_tcom = mean(adv_share_tcom,2).*spend_o1;
revenue_mato = mean(adv_share_mato,2).*spend_o1;

cost_tcom0 = 0.5*(s_tcom0_orig(1,1:3)'-s_hat1_tcom).^2/(5.28*(10^-11)*beta);
cost_tcom = 0.5*(s_tcom_orig(1,1:3)'-s_hat1_tcom).^2/(5.28*(10^-11)*beta);
cost_mato0(:,i) = 0.5*(s_mato0_orig(1,1:3)'-s_hat1_mato).^2/(5.28*(10^-11)*beta);
cost_mato(:,i) = 0.5*(s_mato_orig(1,1:3)'-s_hat1_mato).^2/(5.28*(10^-11)*beta);

Rev_tcom0(:,i) = [sum(revenue_tcom0(period_o1==1));sum(revenue_tcom0(period_o1==2));...
    sum(revenue_tcom0(period_o1==3))];
V_tcom0(:,i)= Rev_tcom0(:,i)-cost_tcom0;

Rev_mato0(:,i) = [sum(revenue_mato0(period_o1==1));sum(revenue_mato0(period_o1==2));...
    sum(revenue_mato0(period_o1==3))];
V_mato0(:,i)= Rev_mato0(:,i)-cost_tcom;

Rev_tcom(:,i) = [sum(revenue_tcom(period_o1==1));sum(revenue_tcom(period_o1==2));...
    sum(revenue_tcom(period_o1==3))];
V_tcom(:,i)= Rev_tcom(:,i)-cost_mato0(:,i);

Rev_mato(:,i) = [sum(revenue_mato(period_o1==1));sum(revenue_mato(period_o1==2));...
    sum(revenue_mato(period_o1==3))];
V_mato(:,i)= Rev_mato(:,i)-cost_mato(:,i);

profit_gap0(:,i) = (V_mato0(:,i)-V_tcom0(:,i))./Rev_tcom0(:,i);
profit_gap(:,i) = (V_mato(:,i)-V_tcom(:,i))./Rev_tcom0(:,i);
profit_gap_d(:,i) = profit_gap0(:,i) - profit_gap(:,i);
end

profit_gap_did = profit_gap_d(3,:) - profit_gap_d(1,:);
profit_gap_se = zeros(3,1);
profit_gap_ci = zeros(3,2);
profit_gap_p = zeros(3,1);
profit_gap0_se = zeros(3,1);
profit_gap0_ci = zeros(3,2);
profit_gap0_p = zeros(3,1); 
profit_gap_d_se = zeros(3,1);
profit_gap_d_ci = zeros(3,2);
profit_gap_d_p = zeros(3,1);
Inv_obj = zeros(6,6);
for i=1:3
    profit_gap_aux = profit_gap(i,2:N+1);
    profit_gap_aux = profit_gap_aux(isnan(profit_gap_aux)==0);
    profit_gap_se(i,1) = sqrt(var(profit_gap_aux));
    profit_gap_ci(i,:) = [quantile(profit_gap_aux,0.025),quantile(profit_gap_aux,0.975)]; 
%    [f,x] = ecdf(profit_gap_aux);
%    profit_gap_p(i,1) = 2*max((x<0).*f);
    
    profit_gap0_aux = profit_gap0(i,2:N+1);
    profit_gap0_aux = profit_gap0_aux(isnan(profit_gap0_aux)==0);
    profit_gap0_se(i,1) = sqrt(var(profit_gap0_aux));
    profit_gap0_ci(i,:) = [quantile(profit_gap0_aux,0.025),quantile(profit_gap0_aux,0.975)]; 
 %   [f,x] = ecdf(profit_gap0_aux);
 %   profit_gap0_p(i,1) = 2*max((x<0).*f);
    
    profit_gap_d_aux = profit_gap_d(i,2:N+1);
    profit_gap_d_aux = profit_gap_d_aux(isnan(profit_gap_d_aux)==0);
    profit_gap_d_se(i,1) = sqrt(var(profit_gap_d_aux));
    profit_gap_d_ci(i,:) = [quantile(profit_gap_d_aux,0.025),quantile(profit_gap_d_aux,0.975)]; 
 %   [f,x] = ecdf(profit_gap_d_aux);
 %   profit_gap_d_p(i,1) = 2*max((x<0).*f);
    Inv_obj(2*i-1:2*i,:) = 100*[profit_gap(i,1),NaN,profit_gap0(i,1),NaN,profit_gap_d(i,1),NaN;...
            profit_gap_ci(i,:),profit_gap0_ci(i,:),profit_gap_d_ci(i,:)];
end
save(path_invobj)
