date

echo "Starting data preparation"
python -W ignore aggregate_online_visitors.py
stata-mp -b do prepare_advertising_data.do
mv *.log temp/
echo "Finished data preparation"


echo "Starting reduced form estimations"
stata-mp -b do analysis_reduced.do
mv *.log temp/
echo "Finished reduced form estimations"


echo "Starting structural estimations"

# CSV to MAT
echo "Transforming csv files to mat"
matlab -r 'csv_to_mat;exit'

# Estimations
echo "Starting master a, b, c and d parallelly"
parallel -q --ungroup --delay 20 matlab -r 'master_{};exit' ::: a b c d >> temp/log.log
echo "Finished master a, b, c, and d - estimations"

# Table compilation and equilibrium conditions
echo "Starting master e and f parallelly"
parallel -q --ungroup matlab -r 'master_{};exit' ::: e f >> temp/log.log
mv output/tableA10.csv output/tableA11.csv
mv output/tableA9.csv output/tableA10.csv
echo "Finished master e and f"

echo "Finished"

date
