set_n;
file_paths;

if altref == 0
load(path_HVG)
else
load(path_444)
end

slant_diff_o = slant_diff(online==1);
slant_diff_p = slant_diff(online==0);
slant_own_o = slant_own(online==1);
slant_own_p = slant_own(online==0);
slant_other_o = slant_other(online==1);
slant_other_p = slant_other(online==0);
period_cont_o0 = period_cont(online==1);
period_cont_p0 = period_cont(online==0);
corr_refo = corr_ref(online==1);
corr_refp = corr_ref(online==0);
size_cont_o = length(slant_diff_o);
size_cont_p = length(slant_diff_p);
size_cont = size_cont_o + size_cont_p;

[s_o,id_cont_o] = bootstrp(N,@slant_moments_online,slant_diff_o,period_cont_o0);
[s_p,id_cont_p] = bootstrp(N,@slant_moments_print,slant_diff_p,period_cont_p0);

slant_diff = [slant_diff_o,slant_diff_o(id_cont_o);...
         slant_diff_p,slant_diff_p(id_cont_p)];
slant_own = [slant_own_o,slant_own_o(id_cont_o);...
         slant_own_p,slant_own_p(id_cont_p)];
slant_other = [slant_other_o,slant_other_o(id_cont_o);...
         slant_other_p,slant_other_p(id_cont_p)];
     
s_diff = [slant_moments_online(slant_diff_o,period_cont_o0);...
          slant_moments_print(slant_diff_p,period_cont_p0)];
s_own = [slant_moments_online(slant_own_o,period_cont_o0);...
         slant_moments_print(slant_own_p,period_cont_p0)];
s_other = [slant_moments_online(slant_other_o,period_cont_o0);...
          slant_moments_print(slant_other_p,period_cont_p0)];

s_emp = [s_own(1:3,1),s_other(1:3,1),s_diff(1:3,1);...
         s_own(7:8,1),s_other(7:8,1),s_diff(7:8,1)];
s_se = [s_own(4:6,1),s_other(4:6,1),s_diff(4:6,1);...
        s_own(9:10,1),s_other(9:10,1),s_diff(9:10,1)];
period_cont_o = [period_cont_o0,period_cont_o0(id_cont_o)];
period_cont_p = [period_cont_p0,period_cont_p0(id_cont_p)];

corr_ref_av = [mean(corr_refo(period_cont_o0==1));mean(corr_refo(period_cont_o0==2));...
     mean(corr_refo(period_cont_o0==3))];

load(path_advo)
ad_num = length(adv_id0);
[adv_id_av,id_spend] = bootstrp(N,@mean,adv_id0);
clear adv_id_av
lodds_o = [[lodds10,lodds10(id_spend)];[lodds20,lodds20(id_spend)];[lodds30,lodds30(id_spend)]];
spend_o = [[spend10,spend10(id_spend)];[spend20,spend20(id_spend)];[spend30,spend30(id_spend)]];
pub_o = [[pub10,pub10(id_spend)];[pub20,pub20(id_spend)];[pub30,pub30(id_spend)]];

period_o = kron([1;2;3],ones(ad_num,N+1));

%%

par_num = 20;

lodds_o1_aux = lodds_o(:,1);
lodds_o1 = lodds_o1_aux(isnan(lodds_o1_aux)==0); 
size_o1= length(lodds_o1);
[lodds_o_av,id_reso] = bootstrp(M,@mean,lodds_o1);
clear lodds_o1_aux lodds_o1 lodds_o_av

lalpha_resrando = normrnd(0,1,size_o1,M); % simulate M nu/sigma_nu for online
xi_resrando1 = normrnd(0,1,size_cont_o,M); % simulate M xi/sigma_xi for online
xi_resrando2 = normrnd(0,1,size_cont_o,M); % simulate M xi/sigma_xi for online
xi_resrandor = normrnd(0,1,size_cont_o,M); % simulate M xi/sigma_xi for reference

size_cont_o1 = sum((period_cont_o(:,1)==1));
size_cont_o2 = sum((period_cont_o(:,1)==2));
size_cont_o3 = sum((period_cont_o(:,1)==3));

solution_o = zeros(N+1,par_num); 

if altprice == 1
price_pri = .33;
else 
price_pri = 1;
end
price_pub = 1;

% This is the beginning of the point estimation

i=1
lodds_oi_aux = lodds_o(:,i);
lodds_oi = lodds_oi_aux(isnan(lodds_oi_aux)==0);        
spend_oi_aux = spend_o(:,i);
spend_oi = spend_oi_aux(isnan(spend_oi_aux)==0);   
pub_oi_aux = pub_o(:,i);
pub_oi = pub_oi_aux(isnan(pub_oi_aux)==0);   
period_oi_aux = period_o(:,i);
period_oi = period_oi_aux(isnan(spend_oi_aux)==0);  
clear lodds_oi_aux spend_oi_aux pub_oi_aux period_oi_aux
size_o = length(lodds_oi);

% This part fixes the prices
if altprice == 1
adv_share_aux_o = exp(lodds_oi)./(1+exp(lodds_oi));

connect_spend_o = price_pri*adv_share_aux_o.*spend_oi.*(pub_oi==0)+...
                     price_pri*adv_share_aux_o.*spend_oi.*(pub_oi==1).*(period_oi~=3)+...
                     price_pub*adv_share_aux_o.*spend_oi.*(pub_oi==1).*(period_oi==3);  
                 
unconnect_spend_o = price_pri*(1-adv_share_aux_o).*spend_oi;               

spend_oi = connect_spend_o + unconnect_spend_o;

adv_share_o = connect_spend_o./spend_oi;

lodds_oi = log(adv_share_o./(1-adv_share_o));
end
% This is the end of price fixing

weight = spend_oi./sum(spend_oi);    
W_1sto = diag(weight);

s_diff_o = [(period_oi==1),(period_oi==2),(period_oi==3)]*s_emp(1:3,3); 
s_pub_o = [(period_oi==1),(period_oi==2),(period_oi==3)]*s_emp(1:3,1).*pub_oi;
      
X_o = [ones(size_o,1),pub_oi,s_diff_o,s_pub_o];
stage1_o = inv(X_o'*W_1sto*X_o)*X_o'*W_1sto*lodds_oi;
lalpha_res = lodds_oi-X_o*stage1_o;
sigma_sqnu = var(sqrt(spend_oi).*lalpha_res);

if i==1
%   nu = lalpha_res;
    period_o1 = period_oi;
    pub_o1 = pub_oi;
    spend_o1 = spend_oi;
%     W_pub = [sum(spend_oi(period_oi==1&pub_oi==1));sum(spend_oi(period_oi==2&pub_oi==1));sum(spend_oi(period_oi==3&pub_oi==1))];  
%     W = [sum(spend_oi(period_oi==1));sum(spend_oi(period_oi==2));sum(spend_oi(period_oi==3))];
%     pub_share = W_pub./W;
end

dalpha_simo_aux = zeros(size_o1,M);
ddalpha_simo_aux = zeros(size_o1,M);

alpha_o = stage1_o(1,1);
theta_o = stage1_o(2,1);
gamma_o = stage1_o(3,1);

delta_o = stage1_o(4,1);

for j=1:M
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);

s_diff_o1 = [(period_o1==1),(period_o1==2),(period_o1==3)]*s_emp(1:3,3); 
s_pub_o1 = [(period_o1==1),(period_o1==2),(period_o1==3)]*s_emp(1:3,1).*pub_o1;

lalpha_simo = alpha_o*ones(size_o1,1) + gamma_o*s_diff_o1 + theta_o*pub_o1 + delta_o*s_pub_o1 + lalpha_ressimo;
alpha_simo = exp(lalpha_simo)./(ones(size_o1,1)+exp(lalpha_simo));
dalpha_simo_aux(:,j) = alpha_simo.*(ones(size_o1,1)-alpha_simo);
ddalpha_simo_aux(:,j) = alpha_simo.*(ones(size_o1,1)-alpha_simo).*(ones(size_o1,1)-2*alpha_simo);
end
dalpha_simo_all = mean(dalpha_simo_aux,2).*spend_o1;
dalpha_simo = dalpha_simo_all.*pub_o1;
ddalpha_simo = mean(ddalpha_simo_aux,2).*spend_o1.*pub_o1;

dmps_o = (5.28*10^-11)*delta_o*[(period_cont_o(:,i)==1),(period_cont_o(:,i)==2),(period_cont_o(:,i)==3)]*...
    [sum(ddalpha_simo(period_o1==1));sum(ddalpha_simo(period_o1==2));sum(ddalpha_simo(period_o1==3))];

mps_o = (5.28*10^-11)*delta_o*[(period_cont_o(:,i)==1),(period_cont_o(:,i)==2),(period_cont_o(:,i)==3)]*...
    [sum(dalpha_simo(period_o1==1));sum(dalpha_simo(period_o1==2));sum(dalpha_simo(period_o1==3))];

Z_o = [(period_cont_o(:,i)~=3),(period_cont_o(:,i)==3),mps_o];
stage2_o = inv(Z_o'*Z_o)*Z_o'*slant_diff(1:size_cont_o,i);
xi = slant_diff(1:size_cont_o,i)-Z_o*stage2_o;
sigma_sqxi = var(xi);
beta = stage2_o(3,1);

s_hat_r = s_emp(1:3,1)-beta*(5.28*10^-11)*(delta_o* [sum(dalpha_simo(period_o1==1));sum(dalpha_simo(period_o1==2));sum(dalpha_simo(period_o1==3))]...
    +gamma_o*[sum(dalpha_simo_all(period_o1==1));sum(dalpha_simo_all(period_o1==2));sum(dalpha_simo_all(period_o1==3))]);

% if i==1
%     dalpha_simo1 = dalpha_simo;
%     mp_o1 = mps_o;
% end
x0bar = [stage2_o;s_hat_r;log(sigma_sqxi)];
x0bar_col1 = x0bar;
[stage2_gmm,fval] = gmm_online(x0bar,alpha_o,theta_o,gamma_o,delta_o,sigma_sqnu,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1,...
    slant_own(1:size_cont_o,i),slant_other(1:size_cont_o,i),period_cont_o(:,i));
diff_origo = stage2_gmm(2,1)-stage2_gmm(1,1);

 solution_o(i,:) = [stage1_o;sigma_sqnu;stage2_o;s_hat_r;log(sigma_sqxi);stage2_gmm;diff_origo];






% This is the end of point estimation, beginning of bootstrapping




parfor (i=2:N+1, 40)
lodds_oi_aux = lodds_o(:,i);
lodds_oi = lodds_oi_aux(isnan(lodds_oi_aux)==0);        
spend_oi_aux = spend_o(:,i);
spend_oi = spend_oi_aux(isnan(spend_oi_aux)==0);   
pub_oi_aux = pub_o(:,i);
pub_oi = pub_oi_aux(isnan(pub_oi_aux)==0);   
period_oi_aux = period_o(:,i);
period_oi = period_oi_aux(isnan(spend_oi_aux)==0);  
size_o = length(lodds_oi);

% This part fixes the prices



if altprice == 1
adv_share_aux_o = exp(lodds_oi)./(1+exp(lodds_oi));

connect_spend_o = price_pri*adv_share_aux_o.*spend_oi.*(pub_oi==0)+...
                     price_pri*adv_share_aux_o.*spend_oi.*(pub_oi==1).*(period_oi~=3)+...
                     price_pub*adv_share_aux_o.*spend_oi.*(pub_oi==1).*(period_oi==3);  
                 
unconnect_spend_o = price_pri*(1-adv_share_aux_o).*spend_oi;               

spend_oi = connect_spend_o + unconnect_spend_o;

adv_share_o = connect_spend_o./spend_oi;

lodds_oi = log(adv_share_o./(1-adv_share_o));
end



% This is the end of price fixing

weight = spend_oi./sum(spend_oi);    
W_1sto = diag(weight);

s_diff_o = [(period_oi==1),(period_oi==2),(period_oi==3)]*s_emp(1:3,3); 
s_pub_o = [(period_oi==1),(period_oi==2),(period_oi==3)]*s_emp(1:3,1).*pub_oi;
      
X_o = [ones(size_o,1),pub_oi,s_diff_o,s_pub_o];
stage1_o = inv(X_o'*W_1sto*X_o)*X_o'*W_1sto*lodds_oi;
lalpha_res = lodds_oi-X_o*stage1_o;
sigma_sqnu = var(sqrt(spend_oi).*lalpha_res);

dalpha_simo_aux = zeros(size_o1,M);
ddalpha_simo_aux = zeros(size_o1,M);

alpha_o = stage1_o(1,1);
theta_o = stage1_o(2,1);
gamma_o = stage1_o(3,1);
delta_o = stage1_o(4,1);



for j=1:M
lalpha_ressimo = sqrt(sigma_sqnu)*(1./sqrt(spend_o1)).*lalpha_resrando(:,j);

s_diff_o1 = [(period_o1==1),(period_o1==2),(period_o1==3)]*s_emp(1:3,3); 
s_pub_o1 = [(period_o1==1),(period_o1==2),(period_o1==3)]*s_emp(1:3,1).*pub_o1;

lalpha_simo = alpha_o*ones(size_o1,1) + gamma_o*s_diff_o1 + theta_o*pub_o1 + delta_o*s_pub_o1 + lalpha_ressimo;
alpha_simo = exp(lalpha_simo)./(ones(size_o1,1)+exp(lalpha_simo));
dalpha_simo_aux(:,j) = alpha_simo.*(ones(size_o1,1)-alpha_simo);
ddalpha_simo_aux(:,j) = alpha_simo.*(ones(size_o1,1)-alpha_simo).*(ones(size_o1,1)-2*alpha_simo);
end



dalpha_simo_all = mean(dalpha_simo_aux,2).*spend_o1;
dalpha_simo = dalpha_simo_all.*pub_o1;
ddalpha_simo = mean(ddalpha_simo_aux,2).*spend_o1.*pub_o1;

dmps_o = (5.28*10^-11)*delta_o*[(period_cont_o(:,i)==1),(period_cont_o(:,i)==2),(period_cont_o(:,i)==3)]*...
    [sum(ddalpha_simo(period_o1==1));sum(ddalpha_simo(period_o1==2));sum(ddalpha_simo(period_o1==3))];

mps_o = (5.28*10^-11)*delta_o*[(period_cont_o(:,i)==1),(period_cont_o(:,i)==2),(period_cont_o(:,i)==3)]*...
    [sum(dalpha_simo(period_o1==1));sum(dalpha_simo(period_o1==2));sum(dalpha_simo(period_o1==3))];

Z_o = [(period_cont_o(:,i)~=3),(period_cont_o(:,i)==3),mps_o];
stage2_o = inv(Z_o'*Z_o)*Z_o'*slant_diff(1:size_cont_o,i);
xi = slant_diff(1:size_cont_o,i)-Z_o*stage2_o;
sigma_sqxi = var(xi);
beta = stage2_o(3,1);

s_hat_r = s_emp(1:3,1)-beta*(5.28*10^-11)*(delta_o* [sum(dalpha_simo(period_o1==1));sum(dalpha_simo(period_o1==2));sum(dalpha_simo(period_o1==3))]...
    +gamma_o*[sum(dalpha_simo_all(period_o1==1));sum(dalpha_simo_all(period_o1==2));sum(dalpha_simo_all(period_o1==3))]);

x0bar = [stage2_o;s_hat_r;log(sigma_sqxi)];
x0bar_col1 = x0bar;
[stage2_gmm,fval] = gmm_online(x0bar,alpha_o,theta_o,gamma_o,delta_o,sigma_sqnu,lalpha_resrando,...
    xi_resrando1,xi_resrando2,xi_resrandor,size_cont_o1,size_cont_o2,size_cont_o3,spend_o1,pub_o1,period_o1,...
    slant_own(1:size_cont_o,i),slant_other(1:size_cont_o,i),period_cont_o(:,i));
diff_origo = stage2_gmm(2,1)-stage2_gmm(1,1);

 solution_o(i,:) = [stage1_o;sigma_sqnu;stage2_o;s_hat_r;log(sigma_sqxi);stage2_gmm;diff_origo];


end










solution_o_se = zeros(par_num,1);
ci_o = zeros(par_num,2);


for i=1:par_num
solution_o_se(i,1) = sqrt(var(solution_o(2:N+1,i)));
ci_o(i,:) = [quantile(solution_o(2:N+1,i),0.025),quantile(solution_o(2:N+1,i),0.975)];
end

solution_o2step = [solution_o(1,:)',solution_o_se,ci_o];
column1 = [[solution_o2step(4,1),NaN];...
           solution_o2step(4,3:4);...
           [solution_o2step(3,1),NaN];...
           solution_o2step(3,3:4);...
           [solution_o2step(15,1),NaN];...
           solution_o2step(15,3:4);...
           [solution_o2step(13,1),NaN];...
           solution_o2step(13,3:4);...
           [solution_o2step(14,1),NaN];...
           solution_o2step(14,3:4);
           NaN(4,2)];
if altref == 0 && altprice ==0       
save(path_mc1)
elseif altref ==1
save(path_ar1)
elseif altprice == 1
save(path_ap1)
end
clearvars -except column1 altref altprice 
