set_n;
file_paths;

if altref == 0
load(path_HVG)
else
load(path_444)
end

slant_diff_o = slant_diff(online==1);
slant_diff_p = slant_diff(online==0);
slant_own_o = slant_own(online==1);
slant_own_p = slant_own(online==0);
slant_other_o = slant_other(online==1);
slant_other_p = slant_other(online==0);
period_cont_o0 = period_cont(online==1);
period_cont_p0 = period_cont(online==0);
corr_refo = corr_ref(online==1);
corr_refp = corr_ref(online==0);
size_cont_o = length(slant_diff_o);
size_cont_p = length(slant_diff_p);
size_cont = size_cont_o + size_cont_p;

[s_o,id_cont_o] = bootstrp(N,@slant_moments_online,slant_diff_o,period_cont_o0);
[s_p,id_cont_p] = bootstrp(N,@slant_moments_print,slant_diff_p,period_cont_p0);

slant_diff = [slant_diff_o,slant_diff_o(id_cont_o);...
         slant_diff_p,slant_diff_p(id_cont_p)];
slant_own = [slant_own_o,slant_own_o(id_cont_o);...
         slant_own_p,slant_own_p(id_cont_p)];
slant_other = [slant_other_o,slant_other_o(id_cont_o);...
         slant_other_p,slant_other_p(id_cont_p)];
     
s_diff = [slant_moments_online(slant_diff_o,period_cont_o0);...
          slant_moments_print(slant_diff_p,period_cont_p0)];
s_own = [slant_moments_online(slant_own_o,period_cont_o0);...
         slant_moments_print(slant_own_p,period_cont_p0)];
s_other = [slant_moments_online(slant_other_o,period_cont_o0);...
          slant_moments_print(slant_other_p,period_cont_p0)];

s_emp = [s_own(1:3,1),s_other(1:3,1),s_diff(1:3,1);...
         s_own(7:8,1),s_other(7:8,1),s_diff(7:8,1)];
s_se = [s_own(4:6,1),s_other(4:6,1),s_diff(4:6,1);...
        s_own(9:10,1),s_other(9:10,1),s_diff(9:10,1)];
period_cont_o = [period_cont_o0,period_cont_o0(id_cont_o)];
period_cont_p = [period_cont_p0,period_cont_p0(id_cont_p)];

corr_ref_av = [mean(corr_refp(period_cont_p0==1));mean(corr_refp(period_cont_p0==2))];
 
load(path_advpr)
ad_num = length(adv_id0);
[adv_id_av,id_spend] = bootstrp(N,@mean,adv_id0);
clear adv_id_av
lodds_p = [[lodds10,lodds10(id_spend)];[lodds20,lodds20(id_spend)]];
spend_p = [[spend10,spend10(id_spend)];[spend20,spend20(id_spend)]];
pub_p = [[pub10,pub10(id_spend)];[pub20,pub20(id_spend)]];

period_p = kron([1;2],ones(ad_num,N+1));



%% Estimation

par_num = 15;
lodds_p1_aux = lodds_p(:,1);
lodds_p1 = lodds_p1_aux(isnan(lodds_p1_aux)==0); 
size_p1= length(lodds_p1);
[lodds_p_av,id_resp] = bootstrp(M,@mean,lodds_p1);
clear lodds_p1_aux lodds_p1 lodds_p_av
size_cont_p1 = sum((period_cont_p(:,1)==1));
size_cont_p2 = sum((period_cont_p(:,1)==2));

lalpha_resrandp = normrnd(0,1,size_p1,M); % simulate M nu/sigma_nu for print
xi_resrandp1 = normrnd(0,1,size_cont_p,M); % simulate M xi/sigma_xi for online
xi_resrandp2 = normrnd(0,1,size_cont_p,M); % simulate M xi/sigma_xi for online
xi_resrandpr = normrnd(0,1,size_cont_p,M); % simulate M xi/sigma_xi for reference

solution_p = zeros(N+1,par_num); 

if altprice == 1
price_pri = .33;
else 
price_pri = 1;
end
price_pub = 1;

% Point estimation
i = 1;
lodds_pi_aux = lodds_p(:,i);
lodds_pi = lodds_pi_aux(isnan(lodds_pi_aux)==0);        
spend_pi_aux = spend_p(:,i);
spend_pi = spend_pi_aux(isnan(spend_pi_aux)==0);   
pub_pi_aux = pub_p(:,i);
pub_pi = pub_pi_aux(isnan(pub_pi_aux)==0);   
period_pi_aux = period_p(:,i);
period_pi = period_pi_aux(isnan(lodds_pi_aux)==0);  
clear lodds_pi_aux spend_pi_aux pub_pi_aux period_pi_aux
size_p = length(lodds_pi);

% This part fixes the prices
if altprice == 1
adv_share_aux_p = exp(lodds_pi)./(1+exp(lodds_pi));

% connect_spend_p = price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==0)+...
%                       price_pub*adv_share_aux_p.*spend_pi.*(pub_pi==1);

connect_spend_p = price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==0)+...
                      price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==1).*(period_pi==2)+...
                      price_pub*adv_share_aux_p.*spend_pi.*(pub_pi==1).*(period_pi==1);
                  
unconnect_spend_p = price_pri*(1-adv_share_aux_p).*spend_pi;                  

spend_pi = connect_spend_p + unconnect_spend_p;

adv_share_p = connect_spend_p./spend_pi;

lodds_pi = log(adv_share_p./(1-adv_share_p));
end
% This is the end of price fixing

weight = spend_pi./sum(spend_pi);    
W_1stp = diag(weight); 

s_diff_p = [(period_pi==1),(period_pi==2)]*s_emp(4:5,3);
s_pub_p = [(period_pi==1),zeros(size_p,1)]*s_emp(4:5,1).*pub_pi;
      
X_p = [ones(size_p,1),pub_pi,s_diff_p,s_pub_p];
stage1_p = inv(X_p'*W_1stp*X_p)*X_p'*W_1stp*lodds_pi;
lalpha_res = lodds_pi-X_p*stage1_p;
sigma_sqnu = var(sqrt(spend_pi).*lalpha_res);

if i==1
    eps = lalpha_res;
    period_p1 = period_pi;
    pub_p1 = pub_pi;
    spend_p1 = spend_pi;
    lodds_av_priv = [sum(lodds_pi(period_pi==1&pub_pi==0).*spend_pi(period_pi==1&pub_pi==0))./sum(spend_pi(period_pi==1&pub_pi==0));...
                     sum(lodds_pi(period_pi==2&pub_pi==0).*spend_pi(period_pi==2&pub_pi==0))./sum(spend_pi(period_pi==2&pub_pi==0))];
    lodds_av_pub = [sum(lodds_pi(period_pi==1&pub_pi==1).*spend_pi(period_pi==1&pub_pi==1))./sum(spend_pi(period_pi==1&pub_pi==1));...
                    sum(lodds_pi(period_pi==2&pub_pi==1).*spend_pi(period_pi==2&pub_pi==1))./sum(spend_pi(period_pi==2&pub_pi==1))];

    W_pub = [sum(spend_pi(period_pi==1&pub_pi==1));sum(spend_pi(period_pi==2&pub_pi==1))];  
    W = [sum(spend_pi(period_pi==1));sum(spend_pi(period_pi==2))];
    pub_share = W_pub./W;
end

dalpha_simp_aux = zeros(size_p1,M);
ddalpha_simp_aux = zeros(size_p1,M);

alpha_p = stage1_p(1,1);
theta_p = stage1_p(2,1);
gamma_p = stage1_p(3,1);
delta_p = stage1_p(4,1);


for j=1:M
lalpha_ressimp = sqrt(sigma_sqnu)*(1./sqrt(spend_p1)).*lalpha_resrandp(:,j);

s_diff_p1 = [(period_p1==1),(period_p1==2)]*s_emp(4:5,3); 
s_pub_p1 = [(period_p1==1),(period_p1==2)]*s_emp(4:5,1).*pub_p1;

lalpha_simp = alpha_p*ones(size_p1,1) + gamma_p*s_diff_p1 + theta_p*pub_p1 + delta_p*s_pub_p1 + lalpha_ressimp;
alpha_simp = exp(lalpha_simp)./(ones(size_p1,1)+exp(lalpha_simp));
dalpha_simp_aux(:,j) = alpha_simp.*(ones(size_p1,1)-alpha_simp);
ddalpha_simp_aux(:,j) = alpha_simp.*(ones(size_p1,1)-alpha_simp).*(ones(size_p1,1)-2*alpha_simp);
end
dalpha_simp_all = mean(dalpha_simp_aux,2).*spend_p1;
dalpha_simp = dalpha_simp_all.*pub_p1;
ddalpha_simp = mean(ddalpha_simp_aux,2).*spend_p1.*pub_p1;

dmps_p = (1.75*10^-10)*delta_p*[(period_cont_p(:,i)==1),zeros(size_cont_p,1)]*...
    [sum(ddalpha_simp(period_p1==1));sum(ddalpha_simp(period_p1==2))];

mp_p = (1.75*10^-10)*delta_p*[(period_cont_p(:,i)==1),zeros(size_cont_p,1)]*...
    [sum(dalpha_simp(period_p1==1));sum(dalpha_simp(period_p1==2))];

Z_p = [ones(size_cont_p,1),mp_p];
stage2_p = inv(Z_p'*Z_p)*Z_p'*slant_diff(size_cont_o+1:size_cont_o+size_cont_p,i);
xi = slant_diff(size_cont_o+1:size_cont_o+size_cont_p,i)-Z_p*stage2_p;
sigma_sqxi= var(xi);
beta = stage2_p(2,1);

s_hat_r = s_emp(4:5,1)-beta*(1.75*10^-10)*(delta_p* [sum(dalpha_simp(period_p1==1));sum(dalpha_simp(period_p1==2))]...
    +gamma_p*[sum(dalpha_simp_all(period_p1==1));sum(dalpha_simp_all(period_p1==2))]);

x0bar = [stage2_p;s_hat_r;log(sigma_sqxi)];
x0bar_col2 = x0bar;
stage2_gmm = gmm_print(x0bar,alpha_p,theta_p,gamma_p,delta_p,sigma_sqnu,lalpha_resrandp,...
    xi_resrandp1,xi_resrandp2,xi_resrandpr,size_cont_p1,size_cont_p2,spend_p1,pub_p1,period_p1,...
    slant_own(size_cont_o+1:size_cont_o+size_cont_p,i),slant_other(size_cont_o+1:size_cont_o+size_cont_p,i),period_cont_p(:,i));

solution_p(i,:) = [stage1_p;sigma_sqnu;stage2_p;s_hat_r;log(sigma_sqxi);stage2_gmm]';

% Bootstrap


parfor (i=2:N+1, 40)
lodds_pi_aux = lodds_p(:,i);
lodds_pi = lodds_pi_aux(isnan(lodds_pi_aux)==0);        
spend_pi_aux = spend_p(:,i);
spend_pi = spend_pi_aux(isnan(spend_pi_aux)==0);   
pub_pi_aux = pub_p(:,i);
pub_pi = pub_pi_aux(isnan(pub_pi_aux)==0);   
period_pi_aux = period_p(:,i);
period_pi = period_pi_aux(isnan(lodds_pi_aux)==0);  
size_p = length(lodds_pi);

% This part fixes the prices
if altprice == 1
adv_share_aux_p = exp(lodds_pi)./(1+exp(lodds_pi));

% connect_spend_p = price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==0)+...
%                       price_pub*adv_share_aux_p.*spend_pi.*(pub_pi==1);

connect_spend_p = price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==0)+...
                      price_pri*adv_share_aux_p.*spend_pi.*(pub_pi==1).*(period_pi==2)+...
                      price_pub*adv_share_aux_p.*spend_pi.*(pub_pi==1).*(period_pi==1);
                  
unconnect_spend_p = price_pri*(1-adv_share_aux_p).*spend_pi;                  

spend_pi = connect_spend_p + unconnect_spend_p;

adv_share_p = connect_spend_p./spend_pi;

lodds_pi = log(adv_share_p./(1-adv_share_p));
end
% This is the end of price fixing

weight = spend_pi./sum(spend_pi);    
W_1stp = diag(weight); 

s_diff_p = [(period_pi==1),(period_pi==2)]*s_emp(4:5,3);
s_pub_p = [(period_pi==1),zeros(size_p,1)]*s_emp(4:5,1).*pub_pi;
      
X_p = [ones(size_p,1),pub_pi,s_diff_p,s_pub_p];
stage1_p = inv(X_p'*W_1stp*X_p)*X_p'*W_1stp*lodds_pi;
lalpha_res = lodds_pi-X_p*stage1_p;
sigma_sqnu = var(sqrt(spend_pi).*lalpha_res);


dalpha_simp_aux = zeros(size_p1,M);
ddalpha_simp_aux = zeros(size_p1,M);

alpha_p = stage1_p(1,1);
theta_p = stage1_p(2,1);
gamma_p = stage1_p(3,1);
delta_p = stage1_p(4,1);


for j=1:M
lalpha_ressimp = sqrt(sigma_sqnu)*(1./sqrt(spend_p1)).*lalpha_resrandp(:,j);

s_diff_p1 = [(period_p1==1),(period_p1==2)]*s_emp(4:5,3); 
s_pub_p1 = [(period_p1==1),(period_p1==2)]*s_emp(4:5,1).*pub_p1;

lalpha_simp = alpha_p*ones(size_p1,1) + gamma_p*s_diff_p1 + theta_p*pub_p1 + delta_p*s_pub_p1 + lalpha_ressimp;
alpha_simp = exp(lalpha_simp)./(ones(size_p1,1)+exp(lalpha_simp));
dalpha_simp_aux(:,j) = alpha_simp.*(ones(size_p1,1)-alpha_simp);
ddalpha_simp_aux(:,j) = alpha_simp.*(ones(size_p1,1)-alpha_simp).*(ones(size_p1,1)-2*alpha_simp);
end
dalpha_simp_all = mean(dalpha_simp_aux,2).*spend_p1;
dalpha_simp = dalpha_simp_all.*pub_p1;
ddalpha_simp = mean(ddalpha_simp_aux,2).*spend_p1.*pub_p1;

dmps_p = (1.75*10^-10)*delta_p*[(period_cont_p(:,i)==1),zeros(size_cont_p,1)]*...
    [sum(ddalpha_simp(period_p1==1));sum(ddalpha_simp(period_p1==2))];

mp_p = (1.75*10^-10)*delta_p*[(period_cont_p(:,i)==1),zeros(size_cont_p,1)]*...
    [sum(dalpha_simp(period_p1==1));sum(dalpha_simp(period_p1==2))];

Z_p = [ones(size_cont_p,1),mp_p];
stage2_p = inv(Z_p'*Z_p)*Z_p'*slant_diff(size_cont_o+1:size_cont_o+size_cont_p,i);
xi = slant_diff(size_cont_o+1:size_cont_o+size_cont_p,i)-Z_p*stage2_p;
sigma_sqxi= var(xi);
beta = stage2_p(2,1);

s_hat_r = s_emp(4:5,1)-beta*(1.75*10^-10)*(delta_p* [sum(dalpha_simp(period_p1==1));sum(dalpha_simp(period_p1==2))]...
    +gamma_p*[sum(dalpha_simp_all(period_p1==1));sum(dalpha_simp_all(period_p1==2))]);

x0bar = [stage2_p;s_hat_r;log(sigma_sqxi)];
x0bar_col2 = x0bar;
stage2_gmm = gmm_print(x0bar,alpha_p,theta_p,gamma_p,delta_p,sigma_sqnu,lalpha_resrandp,...
    xi_resrandp1,xi_resrandp2,xi_resrandpr,size_cont_p1,size_cont_p2,spend_p1,pub_p1,period_p1,...
    slant_own(size_cont_o+1:size_cont_o+size_cont_p,i),slant_other(size_cont_o+1:size_cont_o+size_cont_p,i),period_cont_p(:,i));

solution_p(i,:) = [stage1_p;sigma_sqnu;stage2_p;s_hat_r;log(sigma_sqxi);stage2_gmm]';
end

solution_p_se = zeros(par_num,1);
ci_p = zeros(par_num,2);
for i=1:par_num
solution_p_se(i,1) = sqrt(var(solution_p(2:N+1,i)));
ci_p(i,:) = [quantile(solution_p(2:N+1,i),0.025),quantile(solution_p(2:N+1,i),0.975)];
end
solution_p2step = [solution_p(1,:)',solution_p_se,ci_p];
column2 = [[solution_p2step(4,1),NaN];...
           solution_p2step(4,3:4);...
           [solution_p2step(3,1),NaN];...
           solution_p2step(3,3:4);...
           [solution_p2step(12,1),NaN];...
           solution_p2step(12,3:4);...
           NaN(4,2);...
           [solution_p2step(11,1),NaN];...
           solution_p2step(11,3:4);...
           NaN(2,2)];  

if altref == 0 && altprice ==0       
save(path_mc2)
elseif altref ==1
save(path_ar2)
elseif altprice == 1
save(path_ap2)
end       
clearvars -except column1 column2 altref altprice
