%% Generate the output tables
% Table 4 - main structural estimates
clear
file_paths;
load(path_mc1,'column1')
load(path_mc2,'column2')
load(path_mc3,'column3')
load(path_mc4,'column4')

Tab1 = [column1,column2,column3,column4]; % Assembles Table 4
Tab1(1:4,:) = round(Tab1(1:4,:));
Tab1(5:6,:) = round(Tab1(5:6,:)*100)/100;
Tab1(7:14,:) = round(Tab1(7:end,:)*100*10)/10;
xlswrite(path_tab4,Tab1);

% Table 5 - Decomposition
clear
file_paths;
load(path_decomp)
Tab1 = round(Decomp(:,9:16));
xlswrite(path_tab5,Tab1)

%Table 6 - Net profit advantage of connected owner
clear
file_paths;
load(path_invobj)
Tab1 = round(Inv_obj);
Tab1(:,5:6) = Tab1(:,5:6) * (-1);
Tab1([2 4 6],5:6) = fliplr(Tab1([2 4 6],5:6));
xlswrite(path_tab6,Tab1);

%Table 7 - Priv and government budget changes
clear
file_paths;
load(path_budget)
Tab1 = round([Table(:,3:4),Table(:,1:2),Table(:,5:6)]);
No_in_text = round([Table(1,7);Table(3,7)]);
xlswrite(path_tab7,Tab1)
xlswrite(path_no_in_text,No_in_text)

%Table 8 - Both outlets captured
clear
file_paths;
load(path_bothcap)
Tab1 = round(Effect);
xlswrite(path_tab8,Tab1);

% Table A10 - Alternative reference outlet
clear
file_paths;
load(path_ar1,'column1')
load(path_ar2,'column2')
load(path_ar3,'column3')
load(path_ar4,'column4')

Tab1 = [column1,column2,column3,column4]; % Assembles Table A10
Tab1(1:4,:) = round(Tab1(1:4,:));
Tab1(5:6,:) = round(Tab1(5:6,:)*100)/100;
Tab1(7:14,:) = round(Tab1(7:end,:)*100*10)/10;
xlswrite(path_tabA10,Tab1);

% Table A11 - Alternative advertising prices
clear
file_paths;
load(path_ap1,'column1')
load(path_ap2,'column2')
load(path_ap3,'column3')
load(path_ap4,'column4')

Tab1 = [column1,column2,column3,column4]; % Assembles Table A11
Tab1(1:4,:) = round(Tab1(1:4,:));
Tab1(5:6,:) = round(Tab1(5:6,:)*100)/100;
Tab1(7:14,:) = round(Tab1(7:end,:)*100*10)/10;
xlswrite(path_tabA11,Tab1);

