*** Change the structure of the data 


* Collapse
gen tq = (year-1960)*4 + int((month-1)/3) 
format tq %tq
collapse (sum) spending surface (first) advertiser type start end ///
education culture health ministry other_govt, by(tax_idadvertiser media_color tq)


* Creating a balanced dataset
fillin tax_idadvertiser media_color tq
sort tax_idadvertiser media_color tq
gen year = yofd(dofq(tq))

replace spending=0 if spending==.
replace surface=0 if surface==.

bysort tax_idadvertiser year: egen type2 = min(type) 
drop type
rename type2 type

sort tax_idadvertiser tq _fillin
by tax_idadvertiser: gen orderid=_n
tsset tax_idadvertiser orderid
tsfill

tsfill
foreach v of varlist advertiser type start end education culture health ministry other_govt {
	bysort tax_idadvertiser: carryforward `v', gen(`v'_new)
}
foreach v of varlist advertiser type start end education culture health ministry other_govt {
	drop `v'
	rename `v'_new `v'
}
drop orderid

gen negtq = -tq

sort tax_idadvertiser negtq _fillin
by tax_idadvertiser: gen orderid=_n
tsset tax_idadvertiser orderid
tsfill

foreach v of varlist advertiser type start end other_govt ministry health culture education{
	bysort tax_idadvertiser: carryforward `v', gen(`v'_new)
}

foreach v of varlist advertiser type start end other_govt ministry health culture education{
	drop `v'
	rename `v'_new `v'
}
drop negtq orderid _fillin


* Drop firms who started after or ended before event
sort tax_idadvertiser tq media_color

drop if year<start&(type==1|type==2|type==3|type==4 | type==5)
drop if year>end&(type==1|type==2|type==3|type==4 | type==5)





