clear all


import delimited "input/media_analysis/media_analysis_results.csv", encoding(UTF-8) clear


tab page
split date, p("_")
destring date1, gen(year)
destring date2, gen(month)
drop date1 date2


keep if year>=2013
egen time=group(year month)
*keep if time<=67
keep if time<49
order page year month any all date time
gen corr_share=any/all

foreach X in "444HU" "HVG"{
	preserve
	
		sum time if page == "`X'"
		keep if time >= `r(min)' & time <= `r(max)'
		gen corr_share_ref_aux = corr_share * (page == "`X'") 
		*gen corr_share_ref_aux = corr_share*(page=="444HU") /*Here we can set 444.hu as the reference*/
		*gen corr_share_ref_aux = corr_share*(page=="HVG")    /*Here we can set hvg.hu as the reference*/
		egen corr_share_ref = max(corr_share_ref_aux), by(time)
		gen slant_own = corr_share_ref-corr_share


		keep if page == "INDEX" | page == "ORIGO" | page == "MNO" | page == "NOL"
		gen media = "index" if page=="INDEX"
		replace media = "origo" if page=="ORIGO"
		replace media = "mno" if page=="MNO"
		replace media = "nol" if page=="NOL"


		gen period = .
		replace period=1 if (year==2013|(year==2014&month<6))& (media=="index"|media=="origo")
		replace period=2 if ((year==2014&month>=6)|year==2015) & (media=="index"|media=="origo")
		replace period=3 if year>=2016 &(media=="index"|media=="origo")
		replace period=1 if (year==2013|year==2014|(year==2015&month<2))&(media=="nol"|media=="mno")
		replace period=2 if ((year==2015&month>=2)|year==2016)&(media=="nol"|media=="mno")


		gen slant_i_aux = slant_own*(media=="index")+(1-(media=="index"))*(-10) 
		gen slant_n_aux = slant_own*(media=="nol")+(1-(media=="nol"))*(-10)
		egen slant_other = max(slant_i_aux) if media=="index"|media=="origo", by(time)
		egen slant_other2 = max(slant_n_aux) if media=="nol"|media=="mno", by(time)
		replace slant_other = slant_other2 if media=="nol"|media=="mno"
		drop slant_i_aux slant_n_aux slant_other2

		gen slant_diff=slant_own-slant_other


		drop if time>46 & media == "mno"
		keep if media=="origo"|media=="mno"
		gen online = (media=="origo")


		keep date online period slant_own slant_other slant_diff corr_share_ref
		order date online period slant_own slant_other slant_diff corr_share_ref
		export delimited using "temp/microdata_cont_`X'.csv", replace

	restore
}

