import delimited input/parlamenthu/main_table.csv, varnames(1) encoding("utf-8") clear
keep if inlist(tol, "1994.06.28.", "1998.06.18.", "2002.05.15.", "2006.05.16.", "2010.05.14.", "2014.05.06.")
replace ciklus = "1994-1998" if ciklus == "1994-98"

levelsof ciklus, local(cycles)
foreach X of local cycles{
	distinct pid if ciklus == "`X'"
	assert `r(ndistinct)' == `r(N)'
}

gen party = ""
	replace party = "left" if inlist(kepviselocsoport, "LMP", "MSZP", "SZDSZ") 
	replace party = "right" if inlist(kepviselocsoport, "FIDESZ" ,"FKGP", "Fidesz", "KDNP", "MDF")
	replace party = "far_right" if inlist(kepviselocsoport, "Jobbik") | strpos(kepviselocsoport, "MI") 
	replace party = "independent" if strpos(kepviselocsoport, "ggetlen")

drop if party == "independent"
gen n = 1
collapse (sum) n, by(ciklus party)
fillin ciklus party
replace n = 0 if _fillin==1
egen n_tot = total(n), by(ciklus)
gen int share_ = round(n/n_tot*100)

keep ciklus party sh n_tot
reshape wide share_, i(ciklus) j(party, string)

gen color = ""
	replace color = "left" if share_left > share_right
	replace color = "right" if share_left < share_right


foreach X of varlist share_*{
	tostring `X', replace
	replace `X' = `X' + "\%"
}

keep ciklus share_left share_right share_far_right color
order ciklus share_left share_right share_far_right color
list

dataout, save("output/table1.tex") replace tex 
