clear all
pause on
set more off


use "input/visitors/visitors.dta", clear

gen day = 1
gen edate = mdy(month, day, year)
format edate %td

keep if readershiptype=="valos felhasznalok"

gen all = Telepulestipuskozseg + Telepulestipusegyebvaros + Telepulestipusmegyeszekhely + TelepulestipusBudapest
replace Iskolaivegzettsegegyetem = 0 if Iskolaivegzettsegegyetem==.
replace Iskolaivegzettsegfoiskola = 0 if Iskolaivegzettsegfoiskola==.
gen all2 = Iskolaivegzettsegegyetem + Iskolaivegzettsegfoiskola + Iskolaivegzettsegszakkozepisko + Iskolaivegzettsegszakmunkaskep + Iskolaivegzettseg8altalanosi + Iskolaivegzettseg7vagykevese
gen highskilled =  Iskolaivegzettsegegyetem + Iskolaivegzettsegfoiskola if Iskolaivegzettsegegyetem>0 & Iskolaivegzettsegfoiskola>0
replace highskilled = all - all2 if Iskolaivegzettsegegyetem==0 & Iskolaivegzettsegfoiskola==0

gen village_sh = Telepulestipuskozseg/all
gen city_sh = Telepulestipusegyebvaros/all
gen countycap_sh = Telepulestipusmegyeszekhely/all
gen bp_sh = TelepulestipusBudapest/all
gen rich_sh = (EsomarABCA+EsomarABCB)/(EsomarABCA+EsomarABCB+EsomarABCC1+EsomarABCC2+EsomarABCD+EsomarABCE+EsomarABCna)
gen highsk_sh = highskilled/all

gen period2 = (edate>=td(01jun2014)&edate<td(01jan2016))
gen period3 = (edate>=td(01jan2016))

gen origo = (media=="Origo-itthon")
gen origo_period2 = origo*period2
gen origo_period3 = origo*period3

eststo clear
foreach v in bp_sh countycap_sh city_sh village_sh highsk_sh rich_sh { 
	tempvar weight
	gen `weight' = all/(`v'*(1-`v'))
	*gen `weight' = 1
	eststo: reg `v' origo_period2 origo_period3 origo i.edate [aw = `weight'] if (media=="Index-belfold"|media=="Origo-itthon")&agecategory=="all", r
}
*

esttab using "output/tableA7.tex" ,se r2 replace drop(*edate*) star(* 0.10 ** 0.05 *** 0.01) label


